/*
SUPPORT: sinavk Khairnar, Avinash
*/
/******************************************************************************
 * Job:             Load_STG2DM_Pack_Future_receipt         A5W0V4GZ.BF0002LO *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Rhuta/My Folder/Job_Cycle7                         *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000AH1 *
 *                  PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB000AJS *
 *                  STG_FUTURE_RECEIPT -                    A5W0V4GZ.BB000AOB *
 *                   DIDM_STG.STG_FUTURE_RECEIPT                              *
 * Target Table:    PACK_FUTURE_RECEIPT -                   A5W0V4GZ.BB000AIW *
 *                   DI_DM.PACK_FUTURE_RECEIPT                                *
 *                                                                            *
 * Generated on:    Tuesday, November 10, 2009 2:30:54 PM IST                 *
 * Generated by:    sinruk@row                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0002LO);
%let etls_jobName = %nrquote(Load_STG2DM_Pack_Future_receipt);
%let etls_userID = %nrquote(sinruk@row);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;

%macro rcSetDS(error);
   if &error gt input(symget('trans_rc'),12.) then
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS;

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;

/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

/*============================================================================*
 * Step:            Pre Process & Get Szpk Level            A5W0V4GZ.BH000HSA *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_FUTURE_RECEIPT -                    A5W0V4GZ.BB000AOB *
 *                   DIDM_STG.STG_FUTURE_RECEIPT                              *
 * Target Table:    User Written Code Target -              A5W0V4GZ.BK000EJI *
 *                   DIDM_STG.STG_FUTURE_RECEIPT                              *
 *                                                                            *
 * User Written:    Pre Process & Get Szpk Level                              *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSA);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DIDM_STG.STG_FUTURE_RECEIPT);

%let _INPUT_count = 1;
%let _INPUT = DIDM_STG.STG_FUTURE_RECEIPT;
%let _INPUT_connect = ;
%let _INPUT_engine = BASE;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Users/Rhuta/My Folder/DIDM_STG/STG_FUTURE_RECEIPT(Table);
%let _INPUT_type = 1;

%let _INPUT1 = DIDM_STG.STG_FUTURE_RECEIPT;
%let _INPUT1_connect = ;
%let _INPUT1_engine = BASE;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Users/Rhuta/My Folder/DIDM_STG/STG_FUTURE_RECEIPT(Table);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = DIDM_STG.STG_FUTURE_RECEIPT;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = BASE;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written Code Target(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */
%let _OUTPUT_keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG;


%let _OUTPUT1 = DIDM_STG.STG_FUTURE_RECEIPT;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = BASE;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written Code Target(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */
%let _OUTPUT1_keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG;


/*---- Start of User Written Code  ----*/

%global g_szpk_active_app_flg g_geo_prod_low_data_lvl_size g_prod_lvl
        g_geo_lvl g_curr_start_dt;

%macro etl_pre_process;
/* Identify the latest week from STG_FUTURE_RECEIPT */
%local current_date;
data _null_;
   call symput('current_date',put(today(),date9.));
run;

proc sql noprint;
   select max(RECEIPT_DT) format=date9.
   into :g_curr_start_dt
   from didm_stg.STG_FUTURE_RECEIPT
   where RECEIPT_DT le "&current_date"d;
quit;

%put Current Week Start Date=&g_curr_start_dt;

%if &g_curr_start_dt eq %str(.) or &sqlobs eq 0 %then
   %do;
      %put WARNING: No Data in Stage for current week;
   %end;
%mend etl_pre_process;
%etl_pre_process;

%macro check_szpk_app;
/*Get ACTIVE_APP_FLG for SZPK application*/
PROC SQL noprint;
   select spec_value into :g_szpk_active_app_flg
   from di_dm.global_setting
   where upcase(spec_nm)='ACTIVE_APP_FLG'
   and upcase(app)='SZPK';
QUIT;

/* If Pack application is not set then stop running job */
%if &g_szpk_active_app_flg ne 1 %then
%do;
   %let etl_msg = %etl_msg(mid=5012,args=ACTIVE_APP_FLG(SZPK) GLOBAL_SETTING);
   %put &etl_msg;
   %etl_abort;
%end;

/*Get GEO_PROD_LOW_DATA_LVL_SIZE for size from global settings*/
PROC SQL noprint;
   select spec_value into :g_geo_prod_low_data_lvl_size
   from di_dm.global_setting
   where upcase(spec_nm)='GEO_PROD_LOW_DATA_LVL_SIZE';
QUIT;

/* validation for geo_prod_low_data_lvl_size */
%if &g_szpk_active_app_flg eq 1 and &g_geo_prod_low_data_lvl_size eq %str() %then
%do;
   %let etl_msg = %etl_msg(mid=5012,args=GEO_PROD_LOW_DATA_LVL_SIZE GLOBAL_SETTING);
   %put &etl_msg;
   %etl_abort;
%end;
%else
   %put g_geo_prod_low_data_lvl_size=&g_geo_prod_low_data_lvl_size;

/* Get Prod and Geo levels for SZPK */
PROC SQL noprint;
   select prod_lvl, geo_lvl into :g_prod_lvl, :g_geo_lvl
   from di_dm.data_lvl
   where data_lvl_id=&g_geo_prod_low_data_lvl_size;
QUIT;

%if &sqlobs eq 0 %then
%do;
   %let etl_msg = %etl_msg(mid=5012,args=GEO_PROD_LOW_DATA_LVL_SIZE DATA_LVL);
   %put &etl_msg;
   %etl_abort;
%end;
%else
%do;
   %put Pack prod_lvl=&g_prod_lvl;
   %put Pack geo_lvl=&g_geo_lvl;
%end;
%mend check_szpk_app;

%check_szpk_app;


/*---- End of User Written Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);


/**  Step end Pre Process & Get Szpk Level **/

/*============================================================================*
 * Step:            SAS Sort                                A5W0V4GZ.BH000HSB *
 * Transform:       Sort                                                      *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    User Written Code Target -              A5W0V4GZ.BK000EJI *
 *                   DIDM_STG.STG_FUTURE_RECEIPT                              *
 * Target Table:    Sort Target -                           A5W0V4GZ.BK000EJJ *
 *                   work.SORTED_FUTURE_RECEIPT                               *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSB);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DIDM_STG.STG_FUTURE_RECEIPT);

proc datasets lib = work nolist nowarn memtype = (data view);
   delete SORTED_FUTURE_RECEIPT;
quit;

proc sort data = &SYSLAST
   out = work.SORTED_FUTURE_RECEIPT;
   by
      GEO_ID
      PROD_ID
      RECEIPT_DT
   ;
run;

%rcSet(&syserr);



/**  Step end SAS Sort **/

/*============================================================================*
 * Step:            UW Identify Duplicates                  A5W0V4GZ.BH000HSC *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Sort Target -                           A5W0V4GZ.BK000EJJ *
 *                   work.SORTED_FUTURE_RECEIPT                               *
 * Target Table:    User Written Code Target -              A5W0V4GZ.BK000EJK *
 *                   work.NODUP_FUTURE_RECEIPT                                *
 *                                                                            *
 * User Written:    UW Identify Duplicates                                    *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSC);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.SORTED_FUTURE_RECEIPT);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(SORTED_FUTURE_RECEIPT);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1;
%let _INPUT = work.SORTED_FUTURE_RECEIPT;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Sort Target(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.SORTED_FUTURE_RECEIPT;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Sort Target(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.NODUP_FUTURE_RECEIPT;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = VIEW;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written Code Target(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */
%let _OUTPUT_keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG ETLS_EXCEPTION_COND;


%let _OUTPUT1 = work.NODUP_FUTURE_RECEIPT;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = VIEW;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written Code Target(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */
%let _OUTPUT1_keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG ETLS_EXCEPTION_COND;


/*---- Start of User Written Code  ----*/

Data &_output/view=&_OUTPUT;
   set &SYSLAST;
   by GEO_ID PROD_ID RECEIPT_DT;
   length ETLS_EXCEPTION_COND $100;
   if not last.RECEIPT_DT then
   ETLS_EXCEPTION_COND = "%etl_msg(mid=5351)";
run;
/*---- End of User Written Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);


/**  Step end UW Identify Duplicates **/

/*============================================================================*
 * Step:            SAS Extract                             A5W0V4GZ.BH000HSD *
 * Transform:       Extract                                                   *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB000AJS *
 * Target Table:    Extract Target - work.TEMP_PRODUCT_DM   A5W0V4GZ.BK000EJL *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSD);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DI_DM.PRODUCT_DM);

/*---- Map the columns  ----*/
proc datasets lib = work nolist nowarn memtype = (data view);
   delete TEMP_PRODUCT_DM;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create view work.TEMP_PRODUCT_DM as
      select
         (MAX(PROD_HIER_SK)) as PROD_HIER_SK length = 6,
         PROD_ID,
         (MAX(STD_HIER_PROD_LVL)) as PROD_LVL length = 4
   from &SYSLAST
   group by
      PROD_ID
   ;
quit;

%let SYSLAST = work.TEMP_PRODUCT_DM;

%rcSet(&sqlrc);



/**  Step end SAS Extract **/

/*============================================================================*
 * Step:            SAS Extract                             A5W0V4GZ.BH000HSE *
 * Transform:       Extract                                                   *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000AH1 *
 * Target Table:    Extract Target - work.TEMP_GEOGRAPHY_DM A5W0V4GZ.BK000EJM *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSE);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DI_DM.GEOGRAPHY_DM);

/*---- Map the columns  ----*/
proc datasets lib = work nolist nowarn memtype = (data view);
   delete TEMP_GEOGRAPHY_DM;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create view work.TEMP_GEOGRAPHY_DM as
      select
         (MAX(GEO_HIER_SK)) as GEO_HIER_SK length = 4,
         GEO_ID,
         (MAX(STD_HIER_GEO_LVL)) as GEO_LVL length = 4
   from &SYSLAST
   group by
      GEO_ID
   ;
quit;

%let SYSLAST = work.TEMP_GEOGRAPHY_DM;

%rcSet(&sqlrc);



/**  Step end SAS Extract **/

/*============================================================================*
 * Step:            Lk_future_receipt                       A5W0V4GZ.BH000HSF *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   User Written Code Target -              A5W0V4GZ.BK000EJK *
 *                   work.NODUP_FUTURE_RECEIPT                                *
 *                  Extract Target - work.TEMP_PRODUCT_DM   A5W0V4GZ.BK000EJL *
 *                  Extract Target - work.TEMP_GEOGRAPHY_DM A5W0V4GZ.BK000EJM *
 * Target Table:    Lookup Target -                         A5W0V4GZ.BK000EJN *
 *                   work.LOOKUP_FUTURE_RECEIPT                               *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSF);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(NODUP_FUTURE_RECEIPT TEMP_GEOGRAPHY_DM TEMP_PRODUCT_DM SORTED_FUTURE_RECEIPT);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

%let runTime = %sysfunc(datetime());

proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview0;
quit;

proc sql; create view etls_temp_lookupview0 as
   select * from work.TEMP_PRODUCT_DM
   where PROD_LVL=&g_prod_lvl.;
quit;
proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview1;
quit;

proc sql; create view etls_temp_lookupview1 as
   select * from work.TEMP_GEOGRAPHY_DM
   where GEO_LVL=&g_geo_lvl.;
quit;
proc datasets lib = work nolist nowarn memtype = (data view);
   delete LOOKUP_FUTURE_RECEIPT;
quit;

/*---- Begin DATA step to perform lookups  ----*/
DATA  work.LOOKUP_FUTURE_RECEIPT
         ( keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG ETLS_EXCEPTION_COND
                 PROD_HIER_SK GEO_HIER_SK )
      ;

   attrib GEO_ID length=$32
          PROD_ID length=$32
          RECEIPT_DT length=8 format=DATE9.
          RECEIPT_UNITS length=8 format=NLNUM12.2
          CHANGE_FLG length=$1
          ETLS_EXCEPTION_COND length=$100
          PROD_HIER_SK length=6
          GEO_HIER_SK length=4
          ;

   retain missing0-missing1 0;

   etls_assign_target_value = 0;
   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      /* Build hash h0 from lookup table etls_temp_lookupview0 */
      nlobs = .;
      dsid = open("etls_temp_lookupview0");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then
            do;
               if (h0.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                  missing0 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: etls_temp_lookupview0";
            missing0 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview0";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview0";

         abort 3;
      end;

      /* Build hash h1 from lookup table etls_temp_lookupview1 */
      nlobs = .;
      dsid = open("etls_temp_lookupview1");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h1(dataset: "etls_temp_lookupview1", hashexp: exponent);
            h1.defineKey( "GEO_ID");
            h1.defineData( "GEO_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then
            do;
               if (h1.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: etls_temp_lookupview1";
                  missing1 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: etls_temp_lookupview1";
            missing1 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview1";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview1";

         abort 3;
      end;

      call missing (PROD_ID, PROD_HIER_SK, GEO_ID, GEO_HIER_SK);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set work.NODUP_FUTURE_RECEIPT end = eof;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then
   do;
      rc0 = h0.find();
   end;
   else
      rc0 = missing0;

   /* Is the current key value stored in hash h1?  */
   if (missing1 < 1) then
   do;
      rc1 = h1.find();
   end;
   else
      rc1 = missing1;

   /* Examine success of lookups  */
   if ( rc0=0 and rc1=0 ) then
   do;
      /* Write row to target  */
      output work.LOOKUP_FUTURE_RECEIPT;
      return;
   end;
   else
   do;
      error_total + 1;

      if (rc0 ^= 0) then
      do;
         exception_total + 1;
         if (rc0 = 98) then
         do;
            /* Check: Lookup table has no rows-Write exception row  */
            /* Check: Lookup table has no rows-Set target columns to value  */
            /* Check: Lookup table has no rows-Set target columns to missing  */
            call missing (PROD_HIER_SK);
            etls_assign_target_value = 1;
         end;

         else
         do;
            /* Check: Lookup value not found-Set target columns to missing  */
            call missing (PROD_HIER_SK);
            etls_assign_target_value = 1;
         end;
      end;

      if (rc1 ^= 0) then
      do;
         exception_total + 1;
         if (rc1 = 98) then
         do;
            /* Check: Lookup table has no rows-Write exception row  */
            /* Check: Lookup table has no rows-Set target columns to value  */
            /* Check: Lookup table has no rows-Set target columns to missing  */
            call missing (GEO_HIER_SK);
            etls_assign_target_value = 1;
         end;

         else
         do;
            /* Check: Lookup value not found-Set target columns to missing  */
            call missing (GEO_HIER_SK);
            etls_assign_target_value = 1;
         end;
      end;

      /* Set target columns to value/missing requested?  */
      if (etls_assign_target_value eq 1) then
         /* Write row to target  */
         output work.LOOKUP_FUTURE_RECEIPT;

   end; /* One or more lookups failed */

   if (eof = 1) then
   do;
      put "Source records with errors: " error_total ;
      put "Total lookup exceptions: " exception_total ;
   end;

run;

%rcSet(&syserr);



/**  Step end Lk_future_receipt **/

/*============================================================================*
 * Step:            Val_pack_future_receipt                 A5W0V4GZ.BH000HSG *
 * Transform:       Data Validation                                           *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lookup Target -                         A5W0V4GZ.BK000EJN *
 *                   work.LOOKUP_FUTURE_RECEIPT                               *
 * Target Table:    Data Validation Target -                A5W0V4GZ.BK000EJO *
 *                   work.VALID_FUTURE_RECEIPT                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSG);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.LOOKUP_FUTURE_RECEIPT);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(LOOKUP_FUTURE_RECEIPT);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop=GEO_HIER_SK PROD_HIER_SK); quit; %let syslast=&last;

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate;

   %let runTime = %sysfunc(datetime());

   /* Create the Exception Report  */
   %macro makeReport;

      %if (&m_excp eq 1) %then
      %do;
         options nodate;

         proc sort data = work.etls_Exceptions;
            by x_row;
         run;

         proc print data = work.etls_Exceptions noobs label;
            title1 "Exceptions Found in Table: work.LOOKUP_FUTURE_RECEIPT";
            title2 "%sysfunc(datetime(),nldatmap.)";
         run;

         options date;

      %end;

   %mend makeReport;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete VALID_FUTURE_RECEIPT;
   quit;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_VALID_FUTURE_RECEIPT;
   quit;

   %let etls_Source = &SYSLAST;

   %let m_excp = 0;

   %put %str(NOTE: Cannot create target table as view because error records are moved.);

   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/
   data work.etls_VALID_FUTURE_RECEIPT
         (keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG
                         ETLS_EXCEPTION_COND PROD_HIER_SK GEO_HIER_SK)
        work.etls_Errors
         (keep = GEO_ID PROD_ID RECEIPT_DT RECEIPT_UNITS CHANGE_FLG
                         ETLS_EXCEPTION_COND PROD_HIER_SK GEO_HIER_SK);

      set &etls_Source end=eof;

      i_move = 0;
      retain i_excp &m_excp;

      /*---- Custom Validation: Invalid PROD_ID  ----*/
      if (missing(PROD_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"* %etl_msg(mid=5305,args=PROD_ID)"),$100.);
      end;  /* if (missing(PROD_HIER_SK)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Invalid GEO_ID  ----*/
      if (Missing(GEO_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"* %etl_msg(mid=5305,args=GEO_ID)"),$100.);
      end;  /* if (Missing(GEO_HIER_SK)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Only Future Deletes allowed.  ----*/
      if (RECEIPT_DT <= "&g_curr_start_dt"d AND upcase (CHANGE_FLG )="&etl_delete_flg") then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5310)"),$100.);
      end;  /* if (RECEIPT_DT <= "&g_curr_start_dt"d AND upcase (CHANGE_FLG )="&etl_delete_flg") */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Exception Records  ----*/
      if (ETLS_EXCEPTION_COND ne "") then
      do;
         i_move = 1;
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else
      do;
      end;  /* else */

      /* move record to error file  */
      if (i_move) then
         output work.etls_Errors;
      /* move record to output file  */
      else
         output work.etls_VALID_FUTURE_RECEIPT;

      if eof then
      do;
         /* create macro flags  */
         call symput("m_excp", put(i_excp, 1.));
      end;

   run;

   %rcSet(&syserr);

   %let etls_Source = work.etls_VALID_FUTURE_RECEIPT;

   /* add ETL_Error_JobRunTime variable to error table  */
   data work.etls_Errors;
      set work.etls_Errors;
      format ETL_Error_JobRunTime datetime16.;
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
   run;

   /* update the errors table  */
   proc append base = DI_MON.STG_FUTURE_RECEIPT_X 
               data=work.ETLS_ERRORS_VW; 
   run; 

   proc append base=work._temp
               data = work.etls_Errors force;
   run;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;

   /*---- Map the columns  ----*/
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete VALID_FUTURE_RECEIPT;
   quit;

   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.VALID_FUTURE_RECEIPT as
         select
            GEO_ID,
            PROD_ID,
            RECEIPT_DT,
            RECEIPT_UNITS,
            CHANGE_FLG,
            ETLS_EXCEPTION_COND,
            PROD_HIER_SK,
            GEO_HIER_SK
               label = 'Geography Hierarchy Key'
      from work.etls_VALID_FUTURE_RECEIPT
      ;
   quit;

   %let SYSLAST = work.VALID_FUTURE_RECEIPT;

   %goto STEP_CONTINUE;

   %STEP_ERR:

      %let sysrc = 9999;
      %rcSet(&sysrc);

   %STEP_CONTINUE:

%mend etls_Validate;
%etls_Validate;



/**  Step end Val_pack_future_receipt **/

/*============================================================================*
 * Step:            Splt_pack_future_receipt                A5W0V4GZ.BH000HSH *
 * Transform:       Splitter                                                  *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Data Validation Target -                A5W0V4GZ.BK000EJO *
 *                   work.VALID_FUTURE_RECEIPT                                *
 * Target Tables:   Splitter Target 1 -                     A5W0V4GZ.BK000EJP *
 *                   work.tmp_future_receipts_del                             *
 *                  Splitter Target 2 -                     A5W0V4GZ.BK000EJQ *
 *                   work.TEMP_PACK_FUTURE_RECEIPT                            *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSH);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.VALID_FUTURE_RECEIPT);

/* System options  */
options obs=max;

proc datasets lib=work nolist nowarn memtype = (data view);
   delete tmp_future_receipts_del;
   delete TEMP_PACK_FUTURE_RECEIPT;
quit;

data
     work.tmp_future_receipts_del
     work.TEMP_PACK_FUTURE_RECEIPT ;
   set &SYSLAST;
   if upcase(CHANGE_FLG)  eq  "&etl_delete_flg" then
      output work.tmp_future_receipts_del;
   if upcase(CHANGE_FLG)  ne "&etl_delete_flg" then
      output work.TEMP_PACK_FUTURE_RECEIPT;
run;

%rcSet(&syserr);



/**  Step end Splt_pack_future_receipt **/

/*============================================================================*
 * Step:            Load_pack_future_receipt                A5W0V4GZ.BH000HSI *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Splitter Target 2 -                     A5W0V4GZ.BK000EJQ *
 *                   work.TEMP_PACK_FUTURE_RECEIPT                            *
 * Target Table:    PACK_FUTURE_RECEIPT -                   A5W0V4GZ.BB000AIW *
 *                   DI_DM.PACK_FUTURE_RECEIPT                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSI);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.TEMP_PACK_FUTURE_RECEIPT);

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1;
%let etls_numIndex = -1;
%let etls_lastTable = &SYSLAST;

%let etls_reccheckexist = 0;
%let etls_recordsbefore = 0;
%macro etls_recordCheck;
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, DATA)) or
            %sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, VIEW)));

      %if (&etls_recCheckExist) %then
      %do;
         proc sql noprint;
            select count(*) into :etls_recordsbefore from di_dm.PACK_FUTURE_RECEIPT;
         quit;

       %put etls_recordsbefore = &etls_recordsbefore;
      %end;
   %mend etls_recordCheck;
 %etls_recordCheck;

   %let etls_table = %nrquote(PACK_FUTURE_RECEIPT);
   %let etls_lib   = %nrquote(DI_DM);


%macro etls_loader;
/*---- Define load data macro  ----*/

/* --------------------------------------------------------------
   Load Technique Selection: Update - Matching=ModifyUsingIndex, New=ModifyUsingIndex
   Blanks may replace non-blanks: true
   Constraint and index action selections: 'INIT','ASIS','INIT','ASIS'
   Additional options selections...
      Set unmapped to missing on updates: false
   -------------------------------------------------------------- */

   /*---- Map the columns  ----*/
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5TR69CV;
   quit;

   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.W5TR69CV as
         select
            GEO_HIER_SK,
            PROD_HIER_SK,
            RECEIPT_DT
               informat = DATE9.,
            RECEIPT_UNITS
      from &etls_lastTable
      ;
   quit;

   %let SYSLAST = work.W5TR69CV;

   %let etls_lastTable = &SYSLAST;
   %let etls_tableOptions = ;

   /* Determine if the target table exists  */
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, DATA)) or
         %sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, VIEW)));

   %if (&etls_tableExist eq 0) %then /* if table does not exist  */
   %do;
       %etl_msg(mid=5005,args=di_dm.PACK_FUTURE_RECEIPT);
       %etl_abort;
   %end;
   %else %do; /* if table exists  */
     %if &Full_refresh eq 0 %then %do; /* Load type: Insert Update */
        data DI_DM.PACK_FUTURE_RECEIPT;
         set &etls_lastTable (rename=(RECEIPT_UNITS = etls_temp0));
         modify DI_DM.PACK_FUTURE_RECEIPT
                 key = PRIM_KEY;
         if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or
         _iorc_ eq %sysrc(_SOK) then
         do;
           RECEIPT_UNITS = etls_temp0;

          /* if the record exists in the master, then replace it  */
           if _iorc_ eq %sysrc(_SOK) then
           replace;

         /* if the record does not exist in the master, then add it  */
           else
            output;
         end;
         _iorc_ = 0;
         _error_ = 0;
       run;

       %rcSet(&syserr);

       proc datasets lib = work nolist nowarn memtype = (data view);
         delete W5TR69CV;
       quit;
   %end;
   %else %do; /* Full Refresh option set */
      proc sql noprint;
      select count (*) into : cnt_del from DI_DM.PACK_FUTURE_RECEIPT;
    quit;
    %if &cnt_del gt 0 %then %do;
         %DI_UTIL_TRUNCATE_TABLE(di_dm.PACK_FUTURE_RECEIPT);
     %end;
    proc append base = di_dm.PACK_FUTURE_RECEIPT
               data =TEMP_PACK_FUTURE_RECEIPT (drop= GEO_ID PROD_ID CHANGE_FLG ETLS_EXCEPTION_COND);
    quit;
   %end;
 %end;
   /* Get number of records in table  */
   %let etls_recCheckExist = 0;
   %let etls_recordsAfter = 0;
   %macro etls_recordCheck;
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, DATA)) or
            %sysfunc(exist(DI_DM.PACK_FUTURE_RECEIPT, VIEW)));

      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck;
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck));
         /* Turn off syntaxcheck option to perform following steps  */
         options nosyntaxcheck;

         proc contents data = DI_DM.PACK_FUTURE_RECEIPT out = work.etls_contents(keep = nobs) noprint;
         run;

         data _null_;
            set work.etls_contents (obs = 1);
            call symput("etls_recordsAfter", left(put(nobs,32.)));
         run;

         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;

         /* Reset syntaxcheck option to previous setting  */
         options &etls_syntaxcheck;
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;

%mend etls_loader;
%etls_loader;



/**  Step end Load_pack_future_receipt **/

/*============================================================================*
 * Step:            UW-Delete                               A5W0V4GZ.BH000HSJ *
 * Transform:       Publish to Archive                                        *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Splitter Target 1 -                     A5W0V4GZ.BK000EJP *
 *                   work.tmp_future_receipts_del                             *
 *                                                                            *
 * User Written:    UW - Delete                                               *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HSJ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.tmp_future_receipts_del);

%let _INPUT_count = 1;
%let _INPUT = work.tmp_future_receipts_del;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Splitter Target 1(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.tmp_future_receipts_del;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Splitter Target 1(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 0;
/*---- Start of User Written Code  ----*/

data DI_DM.PACK_FUTURE_RECEIPT;
set &SYSLAST;
modify DI_DM.PACK_FUTURE_RECEIPT
key = PRIM_KEY / unique;
if %sysrc(_SOK) eq _iorc_  then remove;
else _error_=0;
run;
%let etls_recordsAfter = %di_util_nobs(DI_DM.PACK_FUTURE_RECEIPT);
/*---- End of User Written Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);


/**  Step end UW-Delete **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/
%etls_sendjobstatus(source_table = DIDM_STG.STG_FUTURE_RECEIPT);

