/* 
SUPPORT: sinsik Kannarath, Sarita
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Pack_dm                     A5RCIHUB.BA0001Y2 * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sourabh/My Folder/Cycle_4/Main_SPK                 * 
 *                                                                            * 
 * Server:          MIMain                                  A5RCIHUB.AQ000003 * 
 *                                                                            * 
 * Source Tables:   STG_PACK_DM - DIDM_STG.STG_PACK_DM      A5RCIHUB.BR0000OQ * 
 *                  PACK_TYPE - DI_DM.PACK_TYPE             A5RCIHUB.BR00009Q * 
 * Target Table:    PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 *                                                                            * 
 * Generated on:    Wednesday, November 12, 2008 11:50:06 AM IST              * 
 * Generated by:    sinsoj@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5RCIHUB.BA0001Y2);
%let etls_jobName = %nrquote(Load_STG2DM_Pack_dm);
%let etls_userID = %nrquote(sinsoj@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);


/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            User Written get_values                 A5RCIHUB.BC0009SO * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_PACK_DM - DIDM_STG.STG_PACK_DM      A5RCIHUB.BR0000OQ * 
 * Target Table:    User Written get_values -               A5RCIHUB.BE0008GJ * 
 *                   work.STG_PACK_DM                                         * 
 *                                                                            * 
 * User Written:    get_values                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009SO);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DIDM_STG.STG_PACK_DM); 

%let _INPUT_count = 1;
%let _INPUT = DIDM_STG.STG_PACK_DM;
%let _INPUT_connect = ;
%let _INPUT_engine = BASE;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_DM(Table);
%let _INPUT_type = 1;

%let _INPUT1 = DIDM_STG.STG_PACK_DM;
%let _INPUT1_connect = ;
%let _INPUT1_engine = BASE;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_DM(Table);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.STG_PACK_DM;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written get_values(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG;


%let _OUTPUT1 = work.STG_PACK_DM;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written get_values(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG;


/*---- Start of User Written Code  ----*/ 

%global g_valid_pack_lvls;

%macro etl_get_values;
%let abort = 0 ;

/* Check for existence of DI_DM.PACK_TYPE dataset */
%if NOT %sysfunc(exist(DI_DM.PACK_TYPE)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PACK_TYPE);
	%put &etl_msg;
	%let abort = 1 ;
%end;
%else %do;
	%let pack_type_obs = %di_util_nobs(DI_DM.PACK_TYPE);
	%if &pack_type_obs = 0 %then 
	%do;
		%put WARNING: No data in DI_DM.PACK_TYPE;
	%end;
%end;

/* Get PACK_LVL */
%let g_valid_pack_lvls=.;
proc sql noprint;
	select pack_lvl into :g_valid_pack_lvls separated by ','
	from di_dm.pack_lvl
	order by pack_lvl;
quit;

%if &g_valid_pack_lvls eq . %then
%do;
   %let etl_msg = %etl_msg(mid=5014,args=Pack_lvl PACK_LVL);
	%put &etl_msg;
	%let abort = 1 ;
%end;
%else %if &g_valid_pack_lvls ne (1,2) %then
%do;
   %let etl_msg = %etl_msg(mid=5305,args=PACK_LVL);
	%put &etl_msg;
	%let abort = 2 ;
%end;

%put G_VALID_PACK_LVLS = &G_VALID_PACK_LVLS.;

%if &abort gt 0 %then 
%do;
	%etl_abort;
%end;

/* Converting  PACK_TYPE Null values to 0 */
data &_OUTPUT;
set &SYSLAST;
if Missing(pack_type) then Pack_type = 0;
run;

%mend etl_get_values;

%etl_get_values;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end User Written get_values **/

/*============================================================================* 
 * Step:            Find the duplicate                      A5RCIHUB.BC0009SP * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written get_values -               A5RCIHUB.BE0008GJ * 
 *                   work.STG_PACK_DM                                         * 
 * Target Table:    User Written Code Target -              A5RCIHUB.BE0008GK * 
 *                   work.STG_PACK_DM_NODUP                                   * 
 *                                                                            * 
 * User Written:    pack_dup                                                  * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009SP);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.STG_PACK_DM); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PACK_DM);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1;
%let _INPUT = work.STG_PACK_DM;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /User Written get_values(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.STG_PACK_DM;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /User Written get_values(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.STG_PACK_DM_NODUP;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written Code Target(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG 
        ETLS_EXCEPTION_COND;


%let _OUTPUT1 = work.STG_PACK_DM_NODUP;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written Code Target(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG 
        ETLS_EXCEPTION_COND;


/*---- Start of User Written Code  ----*/ 

/* SORT for removing duplicates */
proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=&SYSLAST out=sort_tab;
	by PACK_ID;
run;

%let SYSLAST = %nrquote(work.sort_tab);

data &_OUTPUT;
   set &SYSLAST;
   by PACK_ID;
   attrib ETLS_EXCEPTION_COND length=$200.;
   if not (last.PACK_ID) then 
   do;
      ETLS_EXCEPTION_COND="%etl_msg(mid=5351)";
   end;
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Find the duplicate **/

/*============================================================================* 
 * Step:            Lookup                                  A5RCIHUB.BC0009SQ * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   User Written Code Target -              A5RCIHUB.BE0008GK * 
 *                   work.STG_PACK_DM_NODUP                                   * 
 *                  PACK_TYPE - DI_DM.PACK_TYPE             A5RCIHUB.BR00009Q * 
 * Target Table:    Lookup - work.STG_PACK_DM_LOOKUP        A5RCIHUB.BE0008GL * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009SQ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PACK_DM_NODUP);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_PACK_DM_LOOKUP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.STG_PACK_DM_LOOKUP
         ( keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG 
                 ETLS_EXCEPTION_COND )
      ; 
   
   attrib PACK_ID length=$32
          PACK_NM length=$40
          PACK_TYPE length=4
          PACK_LVL length=4
          PACK_DESC length=$100
          ACTIVE_FLG length=4
          ETLS_EXCEPTION_COND length=$200
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_DM.PACK_TYPE */ 
      nlobs = .; 
      dsid = open("DI_DM.PACK_TYPE"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_DM.PACK_TYPE", hashexp: exponent);
            h0.defineKey( "PACK_TYPE");
            h0.defineData( "PACK_TYPE");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.PACK_TYPE";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.PACK_TYPE";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: DI_DM.PACK_TYPE";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.PACK_TYPE";
         
         abort 3; 
      end; 
      
      call missing (PACK_TYPE); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.STG_PACK_DM_NODUP end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.STG_PACK_DM_LOOKUP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to value  */ 
            ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_TYPE)"),$200.);
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.STG_PACK_DM_LOOKUP; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lookup **/

/*============================================================================* 
 * Step:            Data Validation                         A5RCIHUB.BC0009SR * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lookup - work.STG_PACK_DM_LOOKUP        A5RCIHUB.BE0008GL * 
 * Target Table:    Data Validation Target -                A5RCIHUB.BE0008GM * 
 *                   work.STG_PACK_DM_VALID                                   * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009SR);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.STG_PACK_DM_LOOKUP); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PACK_DM_LOOKUP);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop=PACK_NM PACK_DESC); quit; %let syslast=&last; 

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.STG_PACK_DM_LOOKUP"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete STG_PACK_DM_VALID;
   quit;
   
   %let etls_Source = &SYSLAST;
   
   %let m_excp = 0;
   
   %put %str(NOTE: Cannot create target table as view because error records are moved.);
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.STG_PACK_DM_VALID
         (keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG 
                         ETLS_EXCEPTION_COND)
        work.etls_Errors
         (keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG 
                         ETLS_EXCEPTION_COND);
   
      set &etls_Source end=eof;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Invalid Active Flag  ----*/ 
      if (ACTIVE_FLG not in (1,0)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=ACTIVE_FLG)"),$200.); 
      end;  /* if (ACTIVE_FLG not in (1,0)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Pack Level  ----*/ 
      if (PACK_LVL not in (&g_valid_pack_lvls)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_LVL)"),$200.); 
      end;  /* if (PACK_LVL not in (&g_valid_pack_lvls)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Remove Duplicate  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.STG_PACK_DM_VALID;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.STG_PACK_DM_VALID;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = DI_MON.STG_PACK_DM_X 
               data = work.ETLS_ERRORS_VW; 
   run; 
   proc append base = work._temp
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
%mend etls_Validate;
%etls_Validate;



/**  Step end Data Validation **/

/*============================================================================* 
 * Step:            Surrogate Key Generator                 A5RCIHUB.BC0009SS * 
 * Transform:       Surrogate Key Generator                                   * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Data Validation Target -                A5RCIHUB.BE0008GM * 
 *                   work.STG_PACK_DM_VALID                                   * 
 * Target Table:    Surrogate Key Generator -               A5RCIHUB.BE0008GN * 
 *                   work.STG_PACK_DM_SK                                      * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009SS);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.STG_PACK_DM_VALID); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PACK_DM_VALID);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1; 
%let _INPUT = work.STG_PACK_DM_VALID;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = VIEW;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Data Validation Target(WorkTable);
%let _INPUT_type = 1;

%let _OUTPUT_count = 1; 
%let _OUTPUT = work.STG_PACK_DM_SK;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /Surrogate Key Generator(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG PACK_SK;



%let etls_surrKeyAssignMethod = %nrquote(etls_surrKeyFromTgt);
%let etls_startingSurrKey = %nrquote(1);
%let etls_surrKeyLookupTable = ;
%let etls_surrKeyLookupTable_connect = ;
%let etls_surrKeyLookupTable_engine = ;
%let etls_surrKeyLookupTable_memtype = ;
%let etls_surrKeyLookupTable_options = %nrquote();
%let etls_surrKeyLookupTable_alter = %nrquote();
%let etls_surrKeyLookupTable_path = ;
%let etls_surrKeyLookupTable_type = 1;
%let etls_surrKeyLookupColumn = ;
%let etls_updateSurrKeyLookupTable = %nrquote(Yes);
%let etls_newOrExistingKeys = %nrquote(etls_genForNew);
%let etls_keepWhichRecords = %nrquote(etls_keepAllRecords);
%let updateSource = %nrquote(NO);
%let etls_force = %nrquote(No);
%let etls_outputTableOptions = ;
%let etls_bulkloadOrInsertbuff = ;
%let etls_insertBuffSize = ;
%let etls_targetTable = DI_DM.PACK_DM;
%let etls_targetTable_connect = ;
%let etls_targetTable_engine = BASE;
%let etls_targetTable_memtype = DATA;
%let etls_targetTable_options = %nrquote();
%let etls_targetTable_alter = %nrquote();
%let etls_targetTable_path = /Users/Sourabh/My Folder/DI_DM/PACK_DM(Table);
%let etls_targetTable_type = 1;
%let businessKey = PACK_ID;
%let businessKey_count = 1;
%let businessKey0 = 1;
%let businessKey1 = PACK_ID;
%let surrogateKey = PACK_SK;
%let surrogateKey_count = 1;
%let surrogateKey0 = 1;
%let surrogateKey1 = PACK_SK;
%let targetTable = ;
%let options = %nrquote(obs=max);

/* List of target columns to keep  */ 
%let _keep = PACK_ID PACK_NM PACK_TYPE PACK_LVL PACK_DESC ACTIVE_FLG PACK_SK;

%macro createSurrogateKey;

%local etls_maxkey;

 options mprint;

 %if (%nrquote(&options) ne) %then
 %do;
    options &options;
 %end; 

 %if (%nrquote(&etls_targetTable) ne ) %then
 %do;
    %let targetTable = &etls_targetTable; 
 %end;


 /* If generating a new surrogate key only for new records not represented in target, or generating */
 /* the key value from target table, or keeping records from target in output, then target table is */
 /* required.    */
 %if (&etls_newOrExistingKeys   = etls_genForNew or
      &etls_surrKeyAssignMethod = etls_surrKeyFromTgt) %then
 %do;
    %if (%nrquote(&targetTable) eq) %then 
    %do;
       %put ERROR: Missing Target Table Option;
       %let sysrc=8000;
       %goto out;
    %end;
 %end;   

 %if (%nrquote(&surrogateKey) eq) %then 
 %do;
    %put ERROR: Missing Surrogate Key Column Option;
    %let sysrc=8000;
    %goto out;
 %end;

 %if (%nrquote(&businessKey) eq) %then 
 %do;
    %put ERROR: Missing Business Key Column Option;
    %let sysrc=8000;
    %goto out;
 %end;
 
 %let tsyslast = &_INPUT (&_INPUT_options);
   
 %if %upcase(&etls_surrKeyAssignMethod) = ETLS_SURRKEYFROMLOOKUPTABLE and %upcase(%substr(&etls_updateSurrKeyLookupTable,1,1)) = Y %then
    %let etls_updateSurrKeyLookupTable = Y;
 %else %let etls_updateSurrKeyLookupTable = N;
    
 /* If merge will need to be done, sort input table */
 %if %upcase(&etls_newOrExistingKeys) = ETLS_GENFORNEW %then
 %do;    
    /* determine member type of source table, can not sort Views */
    %let updateSource = %upcase(%nrquote(&updateSource));
    %if (%nrquote(&_INPUT_memtype) eq DATA and (%upcase(&updateSource) eq YES)) %then
       %let updateSource = Y;
    %else
       %let updateSource = N;
   
    proc sort data = &tsyslast 
       %if (&updateSource eq N) %then
       %do; /* %if - the source cannot be updated - save to a temp table */
          out = work.etls_sortedSource
          %let tsyslast = work.etls_sortedSource; 
       %end; /* %if - the source cannot be updated */ 
       %if (%upcase(&etls_force = YES)) %then 
       %do;
         force
       %end;  
    ;
    by &businesskey;
    run;
 %end;   

  
 /* Assign maxKey to be last surrogate key value assigned, or one less than what next value should be. */
 
 %if &etls_surrKeyAssignMethod = etls_surrKeyFromValue %then
    %let etls_maxKey = %eval(&etls_startingSurrKey - 1); 
 %else %if &etls_surrKeyAssignMethod = etls_surrKeyFromLookupTable %then
 %do;  /* Lookup last surrogate key value from lookup table */
    %if (&etls_surrKeyLookupColumn eq) %then
       %let etls_surrKeyLookupColumn = &surrogateKey;
    proc sql noprint;
       select compress(put(&etls_surrKeyLookupColumn, best32.)) into :etls_maxKey 
       from &etls_surrKeyLookupTable (&etls_surrKeyLookupTable_options);
    quit;
    %if &syserr gt 0 and &syserr ne 4 %then %do;
       %rcset(&syserr);
       %put ERROR: Lookup failed to get last surrogate key value from column: &etls_surrKeyLookupColumn  in lookup table: &etls_surrKeyLookupTable;
       %goto out;
    %end;   
 %end; 
 
 %else %do;  /* set maxKey to highest surrogate key value in target table*/  
    %if (%quote(&targetTable) ne and %sysfunc(exist(&targetTable)) eq 1) %then 
    %do;  /* If physical target table exists, look up maximum surrogate key value assigned */  
       proc sql noprint;
          select compress(put(max(&surrogateKey), best32.)) into :etls_maxKey 
          from &targetTable;
       quit;
       %if &syserr gt 0 and &syserr ne 4 %then %do;
          %rcset(&syserr);
          %put ERROR: Failed to get highest surrogate key value from column: &surrogateKey  in table: &targetTable;
          %goto out;
       %end;
    %end;   
 %end;      
       
 %if (&etls_maxkey eq . or &etls_maxkey eq) %then 
    %let etls_maxkey = 0;


 
 /* If merge will need to be done, sort target table and merge with source table if target table exists. */
 /* Replace output table */
 %if (&etls_newOrExistingKeys = etls_genForNew and %sysfunc(exist(&targetTable)) eq 1) %then  
 %do;
    proc sort data=&targetTable out = work.etls_targetSorted;
       by &businesskey;
       run;
    %if &syserr gt 0 and &syserr ne 4 %then %do;
          %rcset(&syserr);
          %put ERROR: &syserr. Sort of &targetTable  failed, so it will not be replaced;
          %goto out;
    %end;   
       
     /* Delete output table if it exists. It can only be replaced. */
    %if (%sysfunc(exist(&_output)) eq 1) %then 
    %do;
       proc datasets lib = %scan(&_output,1,.) nolist nowarn memtype = (data view);
          delete %scan(&_output,2,.) 
			 %if (&_output_alter ne ) %then
			    (&_OUTPUT_alter);
		    ;
       quit;
    %end;

    data &_output
    %if (&_OUTPUT_options ne or &etls_bulkloadOrInsertbuff ne or %nrquote(&etls_outputTableOptions) ne) %then 
    %do;
       (
       %if %upcase(&etls_bulkloadOrInsertbuff) = ETLS_BULKOAD %then
       %do;
          bulkload = yes
       %end;
       %else %if (%upcase(&etls_bulkloadOrInsertbuff) = ETLS_INSERTBUFF and &etls_insertBuffSize ne) %then
       %do; 
          insertbuff = %nrquote(&etls_insertBuffSize)
       %end;
       %if (%nrquote(&etls_outputTableOptions) ne ) %then %do;
          %nrquote(&etls_outputTableOptions)
       %end;   
		 &_OUTPUT_options
       )
    %end;
    ;  /* (end of data statement */
          
     merge work.etls_targetSorted(in = etls_inTarget)
             &tsyslast 
     %if &etls_keepWhichRecords = etls_keepInputRecords %then
     %do;
       (in = etls_inSource)
     %end;  
     %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
     %do; 
       end=etls_lastRecord
     %end;
          ;
     by &businesskey;
     retain etls_newkey &etls_maxkey;
     drop etls_newkey  etls_inTarget ;
     %if &etls_keepWhichRecords = etls_keepInputRecords %then
     %do;
	drop etls_inSource;
     %end;
     %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
     %do; 
	drop etls_lastRecord;
     %end;
          
          
        /* If just keeping input records, then when a record is read that is not in input table, return */
	/* without saving the record. */
     if not etls_inTarget then
     do;
        etls_newkey + 1;
        &surrogatekey = etls_newkey;
     end;
     %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
     %do; 
        if etls_lastRecord then call symput('etls_maxkey', trim(left(put(etls_newkey,15.))));
     %end; 
     %if &etls_keepWhichRecords = etls_keepInputRecords %then
     %do;
	if etls_inSource then output;
     %end; 
         
     run;

     proc datasets lib = work nolist nowarn memtype=(data view);
          delete etls_targetSorted;
     quit;
       
     %if (%upcase(&updateSource) eq NO) %then
     %do; /* %if - can not update the source table */
        proc datasets lib = work nolist;
             delete etls_sortedSource;
        quit;
     %end; /* %if - can not update the source table */

 %end; 
 
 %else 
 %do; /* %else - generate a new value for all source records and replace output table */
    /* Delete output table if it exists. It can only be replaced. */
    %if (%sysfunc(exist(&_output)) eq 1) %then 
    %do;
       proc datasets lib = %scan(&_output,1,.) nolist nowarn memtype = (data view);
          delete %scan(&_output,2,.) 
			 %if (&_output_alter ne ) %then
     		    (&_OUTPUT_alter);
  	       ;
       quit;
    %end;
    
    data &_output 
    %if (&_OUTPUT_options ne or &etls_bulkloadOrInsertbuff ne or %nrquote(&etls_outputTableOptions) ne ) %then
    %do;
       (
       %if (&etls_bulkloadOrInsertbuff ne or %nrquote(&etls_outputTableOptions) ne) %then 
       %do;
          %if %upcase(&etls_bulkloadOrInsertbuff) = ETLS_BULKOAD %then
          %do;
             bulkload=yes
          %end;
          %else %if (%upcase(&etls_bulkloadOrInsertbuff) = ETLS_INSERTBUFF and &etls_insertBuffSize ne) %then
          %do; 
             insertbuff=%nrquote(&etls_insertBuffSize)
          %end;
          %if (%nrquote(&etls_outputTableOptions) ne) %then %do;
             %nrquote(&etls_outputTableOptions)
          %end;  
       %end;
	    &_OUTPUT_options
       )  
    %end;
    ;  /* End data statement */
       
    %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
    %do; 
       set &tsyslast end=etls_endOfSource; 
       drop etls_endOfSource;
    %end;
    %else %do;
       set &tsyslast;
    %end;   
    retain &surrogateKey &etls_maxKey;
    &surrogateKey + 1;
    %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
    %do;
       if etls_endOfSource then call symput('etls_maxkey', trim(left(put(&surrogateKey,15.))));
    %end;   
    run; 
 %end; 
 
 %if (%upcase(&etls_updateSurrKeyLookupTable) = YES) %then
 %do; 
    proc sql;
       update &etls_surrKeyLookupTable (&etls_surrKeyLookupTable_options)
       set &etls_surrKeyLookupColumn = &etls_maxkey;
    run;
 %end;   
 
 %out:
 %RCSET(&syserr);
%mend;

%createSurrogateKey;

%rcSet(&syserr); 
%rcSet(&sysrc); 
%rcSet(&sqlrc); 



/**  Step end Surrogate Key Generator **/

/*============================================================================* 
 * Step:            Loader                                  A5RCIHUB.BC0009ST * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Surrogate Key Generator -               A5RCIHUB.BE0008GN * 
 *                   work.STG_PACK_DM_SK                                      * 
 * Target Table:    PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009ST);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.STG_PACK_DM_SK); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(STG_PACK_DM_SK);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 

/* --------------------------------------------------------------
   Load Technique Selection: Update - Matching=ModifyUsingIndex, New=ModifyUsingIndex
   Blanks may replace non-blanks: true
   Constraint and index action selections: 'INIT','ASIS','INIT','ASIS'
   Additional options selections... 
      Set unmapped to missing on updates: true 
   -------------------------------------------------------------- */
%macro etls_loader;

   %let etls_tableOptions = ;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_DM, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_DM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_DM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(PACK_DM);
   %let etls_lib   = %nrquote(DI_DM);
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.PACK_DM, DATA)) or 
         %sysfunc(exist(DI_DM.PACK_DM, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data DI_DM.PACK_DM;
         attrib PACK_SK length = 6; 
         attrib PACK_ID length = $32; 
         attrib PACK_NM length = $40; 
         attrib PACK_TYPE length = 4; 
         attrib PACK_LVL length = 4; 
         attrib PACK_DESC length = $100; 
         attrib ACTIVE_FLG length = 4; 
         call missing(of _all_);
         stop;
      run;
      
      %rcSet(&syserr); 
      
      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = DI_DM nolist; 
         modify PACK_DM; 
            index create PACK_ID;
      quit; 
      
      %rcSet(&syserr); 
      
      /*---- Create the integrity constraints for a table  ----*/ 
      %put %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify PACK_DM;
            ic create not null (PACK_SK);
            ic create not null (PACK_ID);
            ic create not null (PACK_NM);
            ic create not null (PACK_LVL);
            ic create not null (ACTIVE_FLG);
            ic create PACK_SK = primary key (PACK_SK);
      quit;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   data DI_DM.PACK_DM; 
   
      set &etls_lastTable 
             (rename=(PACK_ID = etls_temp0
                      PACK_NM = etls_temp1
                      PACK_TYPE = etls_temp2
                      PACK_LVL = etls_temp3
                      PACK_DESC = etls_temp4
                      ACTIVE_FLG = etls_temp5))
      ; 
      
      modify DI_DM.PACK_DM
            key = PACK_SK;
            
      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or 
         _iorc_ eq %sysrc(_SOK) then  
      do; 
         PACK_ID = etls_temp0;
         PACK_NM = etls_temp1;
         PACK_TYPE = etls_temp2;
         PACK_LVL = etls_temp3;
         PACK_DESC = etls_temp4;
         ACTIVE_FLG = etls_temp5;
         
         /* if the record exists in the master, then replace it  */ 
         if _iorc_ eq %sysrc(_SOK) then 
            replace; 
         
         /* if the record does not exist in the master, then add it  */ 
         else 
            output; 
      end; 
      
      _iorc_ = 0; 
      _error_ = 0; 
      
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_DM, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_DM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_DM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;



/**  Step end Loader **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendJobStatus(source_table = DIDM_STG.STG_PACK_DM);
