/* 
SUPPORT: sinsik Kannarath, Sarita
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Pack_group_geo_settings     A5RCIHUB.BA0001XS * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sourabh/My Folder/Cycle_4/Main_SPK                 * 
 *                                                                            * 
 * Server:          MIMain                                  A5RCIHUB.AQ000003 * 
 *                                                                            * 
 * Source Tables:   GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5RCIHUB.BR000083 * 
 *                  STG_PACK_GROUP_GEO_SETTINGS -           A5RCIHUB.BR0000OS * 
 *                   DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS                     * 
 *                  PACK_GROUP - DI_DM.PACK_GROUP           A5RCIHUB.BR00009J * 
 * Target Table:    PACK_GROUP_GEO_SETTINGS -               A5RCIHUB.BR00009K * 
 *                   DI_DM.PACK_GROUP_GEO_SETTINGS                            * 
 *                                                                            * 
 * Generated on:    Wednesday, November 12, 2008 11:50:23 AM IST              * 
 * Generated by:    sinsoj@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5RCIHUB.BA0001XS);
%let etls_jobName = %nrquote(Load_STG2DM_Pack_group_geo_settings);
%let etls_userID = %nrquote(sinsoj@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            Uw_check_exist                          A5RCIHUB.BC0009QO * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_PACK_GROUP_GEO_SETTINGS -           A5RCIHUB.BR0000OS * 
 *                   DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS                     * 
 * Target Table:    User Written Code Target -              A5RCIHUB.BE0008EU * 
 *                   DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS                     * 
 *                                                                            * 
 * User Written:    check_exist                                               * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009QO);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS); 

%let _INPUT_count = 1;
%let _INPUT = DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS;
%let _INPUT_connect = ;
%let _INPUT_engine = BASE;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_GROUP_GEO_SETTINGS(Table);
%let _INPUT_type = 1;

%let _INPUT1 = DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS;
%let _INPUT1_connect = ;
%let _INPUT1_engine = BASE;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_GROUP_GEO_SETTINGS(Table);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = BASE;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written Code Target(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST;


%let _OUTPUT1 = DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = BASE;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written Code Target(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST;


/*---- Start of User Written Code  ----*/ 

%macro etl_check_exist;

%let abort = 0 ;

/* Check for existence of DI_DM.PACK_GROUP dataset */
%if NOT %sysfunc(exist(DI_DM.PACK_GROUP)) %then 
%do;
	%let etl_msg = %etl_msg(mid=5005,args=DI_DM.PACK_GROUP);
	%put &etl_msg;
	%let abort = 1 ;
%end;

/* Check for existence of DI_DM.GEOGRAPHY_DM dataset */
%if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then 
%do;
	%let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
	%put &etl_msg;
	%let abort = 2 ;
%end;

%if &abort gt 0 %then 
%do;
%etl_abort;
%end;

%mend etl_check_exist;
%etl_check_exist;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_check_exist **/

/*---- Start of User Written Code  ----*/ 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Join_pack_group;
quit;

proc sql;
   create table work.Join_pack_group as
   select
      STG_PACK_GROUP_GEO_SETTINGS.PACK_GROUP_ID length = 8,
      STG_PACK_GROUP_GEO_SETTINGS.GEO_ID length = 32,
      STG_PACK_GROUP_GEO_SETTINGS.OPENING_COST length = 8   
         format = NLNUM12.2
         informat = NLNUM12.2,
      STG_PACK_GROUP_GEO_SETTINGS.HANDLING_COST length = 8   
         format = NLNUM12.2
         informat = NLNUM12.2,
      PACK_GROUP.PACK_GROUP_ID as PACK_GROUP_ID_CHK length = 8,
      PACK_GROUP.PACK_GROUP_NM length = 40
   from
      DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS left join 
      DI_DM.PACK_GROUP
         on
         (
            STG_PACK_GROUP_GEO_SETTINGS.PACK_GROUP_ID = PACK_GROUP.PACK_GROUP_ID
         )
   ;
quit;

%rcSet(&sqlrc); 

/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Lkp_geo_id                              A5RCIHUB.BC0009QQ * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   SQL Join Target - work.Join_pack_group  A5RCIHUB.BE0008EV * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5RCIHUB.BR000083 * 
 * Target Table:    Lookup Target - work.Lkp_geo_id         A5RCIHUB.BE0008EW * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009QQ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Join_pack_group);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_geo_id;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_geo_id
         ( keep = GEO_HIER_SK PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST 
                 PACK_GROUP_ID_CHK FACILITY_TYPE )
      ; 
   
   attrib GEO_HIER_SK length=4 label="Geography Hierarchy Key"
          PACK_GROUP_ID length=8
          GEO_ID length=$32
          OPENING_COST length=8 format=NLNUM12.2
          HANDLING_COST length=8 format=NLNUM12.2
          PACK_GROUP_ID_CHK length=8
          FACILITY_TYPE length=4 label="Facility Type"
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */ 
      nlobs = .; 
      dsid = open("DI_DM.GEOGRAPHY_DM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h0.defineKey( "GEO_ID");
            h0.defineData( "FACILITY_TYPE",
                           "GEO_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";
         
         abort 3; 
      end; 
      
      call missing (GEO_ID, FACILITY_TYPE, GEO_HIER_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.Join_pack_group end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_geo_id; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (FACILITY_TYPE, GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (FACILITY_TYPE, GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_geo_id; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_geo_id **/

/*============================================================================* 
 * Step:            Uw_check_duplicates                     A5RCIHUB.BC0009QR * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lookup Target - work.Lkp_geo_id         A5RCIHUB.BE0008EW * 
 * Target Table:    User Written Code Target -              A5RCIHUB.BE0008EX * 
 *                   work.Uw_check_duplicates                                 * 
 *                                                                            * 
 * User Written:    Check duplicates                                          * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009QR);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Lkp_geo_id); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_geo_id);

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1;
%let _INPUT = work.Lkp_geo_id;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Lookup Target(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.Lkp_geo_id;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Lookup Target(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.Uw_check_duplicates;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /User Written Code Target(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = GEO_HIER_SK PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST 
        PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND FACILITY_TYPE;


%let _OUTPUT1 = work.Uw_check_duplicates;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /User Written Code Target(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = GEO_HIER_SK PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST 
        PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND FACILITY_TYPE;


/*---- Start of User Written Code  ----*/ 

/* SORT for removing duplicates */

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=&SYSLAST out=sort_tab;
	by PACK_GROUP_ID GEO_HIER_SK;
run;

%let SYSLAST = %nrquote(work.sort_tab);

data &_OUTPUT;
set &SYSLAST;
by PACK_GROUP_ID GEO_HIER_SK;
attrib ETLS_EXCEPTION_COND length=$170.;
if not(last.GEO_HIER_SK) then 
   do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5351)"),$170.); 
	end;
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_check_duplicates **/

/*============================================================================* 
 * Step:            Data Validation                         A5RCIHUB.BC0009QS * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    User Written Code Target -              A5RCIHUB.BE0008EX * 
 *                   work.Uw_check_duplicates                                 * 
 * Target Table:    Data Validation Target - work.Val_data  A5RCIHUB.BE0008EY * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009QS);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Uw_check_duplicates); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Uw_check_duplicates);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop = GEO_HIER_SK PACK_GROUP_ID_CHK FACILITY_TYPE); quit; %let syslast=&last; 

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.Uw_check_duplicates"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_data;
   quit;
   
   %let etls_Source = &SYSLAST;
   
   %let m_excp = 0;
   
   %put %str(NOTE: Cannot create target table as view because error records are moved.);
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_data
         (keep = GEO_HIER_SK PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST 
                         PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND FACILITY_TYPE)
        work.etls_Errors
         (keep = GEO_HIER_SK PACK_GROUP_ID GEO_ID OPENING_COST HANDLING_COST 
                         PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND FACILITY_TYPE);
   
      set &etls_Source end=eof;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Invalid Geo_id  ----*/ 
      if (GEO_HIER_SK IN (.,-1,0)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=GEO_ID)"),$170.); 
      end;  /* if (GEO_HIER_SK IN (.,-1,0)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Pack_group_id  ----*/ 
      if (PACK_GROUP_ID ne PACK_GROUP_ID_CHK) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_GROUP_ID)"),$170.); 
      end;  /* if (PACK_GROUP_ID ne PACK_GROUP_ID_CHK) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Opening_cost  ----*/ 
      if ( NOT missing(OPENING_COST) & OPENING_COST lt 0) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=OPENING_COST)"),$170.); 
      end;  /* if ( NOT missing(OPENING_COST) & OPENING_COST lt 0) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Handling_cost  ----*/ 
      if ( NOT missing(HANDLING_COST) & HANDLING_COST lt 0) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=HANDLING_COST)"),$170.); 
      end;  /* if ( NOT missing(HANDLING_COST) & HANDLING_COST lt 0) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Duplicate Record  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_data;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.Val_data;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = DI_MON.STG_PACK_GROUP_GEO_SETTINGS_X 
               data = work.ETLS_ERRORS_VW; 
   run; 
   proc append base = work._temp
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
%mend etls_Validate;
%etls_Validate;



/**  Step end Data Validation **/

/*============================================================================* 
 * Step:            Load_pack_group_geo_settings            A5RCIHUB.BC0009QT * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Data Validation Target - work.Val_data  A5RCIHUB.BE0008EY * 
 * Target Table:    PACK_GROUP_GEO_SETTINGS -               A5RCIHUB.BR00009K * 
 *                   DI_DM.PACK_GROUP_GEO_SETTINGS                            * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009QT);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Val_data); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(val_data);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options obs=max; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 

/* --------------------------------------------------------------
   Load Technique Selection: Update - Matching=ModifyUsingIndex, New=ModifyUsingIndex
   Blanks may replace non-blanks: true
   Constraint and index action selections: 'ASIS','ASIS','ASIS','ASIS'
   Additional options selections... 
      Set unmapped to missing on updates: true 
   -------------------------------------------------------------- */
%macro etls_loader;

   %let etls_tableOptions = ;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_GROUP_GEO_SETTINGS out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(PACK_GROUP_GEO_SETTINGS);
   %let etls_lib   = %nrquote(DI_DM);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39FU;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.W5MU39FU as
         select
            PACK_GROUP_ID,
            GEO_HIER_SK,
            OPENING_COST,
            HANDLING_COST
      from &etls_lastTable
      ;
   quit;
   
   %let SYSLAST = work.W5MU39FU;
   
   %let etls_lastTable = &SYSLAST; 
   %let etls_tableOptions = ; 
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, DATA)) or 
         %sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data DI_DM.PACK_GROUP_GEO_SETTINGS;
         attrib PACK_GROUP_ID length = 8; 
         attrib GEO_HIER_SK length = 4; 
         attrib OPENING_COST length = 8
            format = NLNUM12.2
            informat = NLNUM12.2; 
         attrib HANDLING_COST length = 8
            format = NLNUM12.2
            informat = NLNUM12.2; 
         call missing(of _all_);
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   data DI_DM.PACK_GROUP_GEO_SETTINGS; 
   
      set &etls_lastTable 
             (rename=(OPENING_COST = etls_temp0
                      HANDLING_COST = etls_temp1))
      ; 
      
      modify DI_DM.PACK_GROUP_GEO_SETTINGS
            key = PRIM_KEY;
            
      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or 
         _iorc_ eq %sysrc(_SOK) then  
      do; 
         OPENING_COST = etls_temp0;
         HANDLING_COST = etls_temp1;
         
         /* if the record exists in the master, then replace it  */ 
         if _iorc_ eq %sysrc(_SOK) then 
            replace; 
         
         /* if the record does not exist in the master, then add it  */ 
         else 
            output; 
      end; 
      
      _iorc_ = 0; 
      _error_ = 0; 
      
   run; 
   
   %rcSet(&syserr); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39FU;
   quit;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_GROUP_GEO_SETTINGS, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_GROUP_GEO_SETTINGS out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;



/**  Step end Load_pack_group_geo_settings **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendjobstatus(source_table = DIDM_STG.STG_PACK_GROUP_GEO_SETTINGS);
