/* 
SUPPORT: sinsik Kannarath, Sarita
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Pack_hier_dm                A5RCIHUB.BA0001XV * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sourabh/My Folder/Cycle_4/Main_SPK                 * 
 *                                                                            * 
 * Server:          MIMain                                  A5RCIHUB.AQ000003 * 
 *                                                                            * 
 * Source Tables:   PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 *                  STG_PACK_HIER_DM -                      A5RCIHUB.BR0000OT * 
 *                   DIDM_STG.STG_PACK_HIER_DM                                * 
 *                  PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 * Target Table:    PACK_HIER_DM - DI_DM.PACK_HIER_DM       A5RCIHUB.BR00009L * 
 *                                                                            * 
 * Generated on:    Wednesday, November 12, 2008 11:50:28 AM IST              * 
 * Generated by:    sinsoj@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5RCIHUB.BA0001XV);
%let etls_jobName = %nrquote(Load_STG2DM_Pack_hier_dm);
%let etls_userID = %nrquote(sinsoj@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            Sort_child_pack_id                      A5RCIHUB.BC0009R5 * 
 * Transform:       Sort                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_PACK_HIER_DM -                      A5RCIHUB.BR0000OT * 
 *                   DIDM_STG.STG_PACK_HIER_DM                                * 
 * Target Table:    Sort_child_pack_id -                    A5RCIHUB.BE0008F8 * 
 *                   work.Sort_child_pack_id                                  * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009R5);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DIDM_STG.STG_PACK_HIER_DM); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Sort_child_pack_id;
quit;

proc sort data = &SYSLAST 
   out = work.Sort_child_pack_id; 
   by
      PACK_ID
      CHILD_PACK_ID
   ;
run; 

%rcSet(&syserr); 



/**  Step end Sort_child_pack_id **/

/*============================================================================* 
 * Step:            Ext_pack_dm                             A5RCIHUB.BC0009R6 * 
 * Transform:       Extract                                                   * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 * Target Table:    Ext_pack_dm - work.Ext_pack_dm          A5RCIHUB.BE0008F9 * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009R6);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DI_DM.PACK_DM); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete Ext_pack_dm;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create table work.Ext_pack_dm as
      select
         PACK_SK as C_PACK_SK,
         PACK_ID as C_PACK_ID,
         PACK_LVL as C_PACK_LVL
   from &SYSLAST
   ;
quit;

%let SYSLAST = work.Ext_pack_dm;

%rcSet(&sqlrc); 



/**  Step end Ext_pack_dm **/

/*============================================================================* 
 * Step:            Lkp_pack_dm                             A5RCIHUB.BC0009R7 * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   Sort_child_pack_id -                    A5RCIHUB.BE0008F8 * 
 *                   work.Sort_child_pack_id                                  * 
 *                  PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 *                  Ext_pack_dm - work.Ext_pack_dm          A5RCIHUB.BE0008F9 * 
 * Target Table:    Lkp_pack_dm - work.Lkp_pack_dm          A5RCIHUB.BE0008FA * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009R7);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Sort_child_pack_id Ext_pack_dm);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_pack_dm;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_pack_dm
         ( keep = PACK_ID CHILD_PACK_ID NUMBER_OF_UNITS PACK_SK PACK_LVL CHILD_PACK_SK 
                 CHILD_PACK_LVL )
      ; 
   
   attrib PACK_ID length=$32
          CHILD_PACK_ID length=$32
          NUMBER_OF_UNITS length=6
          PACK_SK length=6
          PACK_LVL length=4
          CHILD_PACK_SK length=6
          CHILD_PACK_LVL length=4
          C_PACK_SK length= 6
          C_PACK_LVL length= 4
          C_PACK_ID length= $32
          ; 
   
   retain missing0-missing1 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_DM.PACK_DM */ 
      nlobs = .; 
      dsid = open("DI_DM.PACK_DM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_DM.PACK_DM", hashexp: exponent);
            h0.defineKey( "PACK_ID");
            h0.defineData( "PACK_SK",
                           "PACK_LVL");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.PACK_DM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.PACK_DM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: DI_DM.PACK_DM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.PACK_DM";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table work.Ext_pack_dm */ 
      nlobs = .; 
      dsid = open("work.Ext_pack_dm"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "work.Ext_pack_dm", hashexp: exponent);
            h1.defineKey( "C_PACK_ID");
            h1.defineData( "C_PACK_SK",
                           "C_PACK_LVL");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: work.Ext_pack_dm";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: work.Ext_pack_dm";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " work.Ext_pack_dm";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.Ext_pack_dm";
         
         abort 3; 
      end; 
      
      call missing (PACK_ID, PACK_SK, PACK_LVL, C_PACK_ID, C_PACK_SK, C_PACK_LVL); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.Sort_child_pack_id end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      C_PACK_ID = CHILD_PACK_ID;
      rc1 = h1.find();
      CHILD_PACK_SK = C_PACK_SK;
      CHILD_PACK_LVL = C_PACK_LVL;
   end; 
   else 
      rc1 = missing1; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_pack_dm; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PACK_SK, PACK_LVL); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PACK_SK, PACK_LVL); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (CHILD_PACK_SK, CHILD_PACK_LVL); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (CHILD_PACK_SK, CHILD_PACK_LVL); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_pack_dm; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_pack_dm **/

/*============================================================================* 
 * Step:            Uw_check_duplicate                      A5RCIHUB.BC0009R8 * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lkp_pack_dm - work.Lkp_pack_dm          A5RCIHUB.BE0008FA * 
 * Target Table:    Uw_check_duplicate -                    A5RCIHUB.BE0008FB * 
 *                   work.Uw_check_duplicate                                  * 
 *                                                                            * 
 * User Written:    Identify Duplicates                                       * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009R8);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Lkp_pack_dm); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_pack_dm);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1;
%let _INPUT = work.Lkp_pack_dm;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Lkp_pack_dm(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.Lkp_pack_dm;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Lkp_pack_dm(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.Uw_check_duplicate;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /Uw_check_duplicate(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_ID CHILD_PACK_ID NUMBER_OF_UNITS PACK_SK PACK_LVL CHILD_PACK_SK 
        CHILD_PACK_LVL ETLS_EXCEPTION_COND;


%let _OUTPUT1 = work.Uw_check_duplicate;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /Uw_check_duplicate(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_ID CHILD_PACK_ID NUMBER_OF_UNITS PACK_SK PACK_LVL CHILD_PACK_SK 
        CHILD_PACK_LVL ETLS_EXCEPTION_COND;


/*---- Start of User Written Code  ----*/ 

data &_OUTPUT/view=&_OUTPUT;
   set &SYSLAST;
   by PACK_ID CHILD_PACK_ID;
	attrib ETLS_EXCEPTION_COND length=$160.;
   if not (last.CHILD_PACK_ID) then 
   do;
      ETLS_EXCEPTION_COND="%etl_msg(mid=5351)";
   end;
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_check_duplicate **/

/*============================================================================* 
 * Step:            Val_pack_id                             A5RCIHUB.BC0009R9 * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Uw_check_duplicate -                    A5RCIHUB.BE0008FB * 
 *                   work.Uw_check_duplicate                                  * 
 * Target Table:    Val_pack_id - work.Val_pack_id          A5RCIHUB.BE0008FC * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009R9);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Uw_check_duplicate); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_pack_dm Uw_check_duplicate);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop = PACK_SK CHILD_PACK_SK); quit; %let syslast=&last; 

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.Uw_check_duplicate"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_pack_id;
   quit;
   
   %let etls_Source = &SYSLAST;
   
   %let m_excp = 0;
   
   %put %str(NOTE: Cannot create target table as view because error records are moved.);
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_pack_id
         (keep = PACK_ID CHILD_PACK_ID NUMBER_OF_UNITS PACK_SK PACK_LVL 
                         CHILD_PACK_SK CHILD_PACK_LVL ETLS_EXCEPTION_COND)
        work.etls_Errors
         (keep = PACK_ID CHILD_PACK_ID NUMBER_OF_UNITS PACK_SK PACK_LVL 
                         CHILD_PACK_SK CHILD_PACK_LVL ETLS_EXCEPTION_COND);
   
      set &etls_Source end=eof;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Invalid Pack_id  ----*/ 
      if (missing(PACK_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_ID)"),$160.); 
         i_move = 1; 
      end;  /* if (missing(PACK_SK)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Child_pack_id  ----*/ 
      if (missing(CHILD_PACK_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=CHILD_PACK_ID)"),$160.); 
         i_move = 1; 
      end;  /* if (missing(CHILD_PACK_SK)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Child_pack_id must be at a lower level than  ----*/ 
      /*----  Pack_id                                                        ----*/ 
      if (PACK_LVL <= CHILD_PACK_LVL) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5331,args=PACK_LVL CHILD_PACK_LVL)"),$160.); 
         i_move = 1; 
      end;  /* if (PACK_LVL < CHILD_PACK_LVL) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Check for valid number_of_units  ----*/ 
      if (missing(NUMBER_OF_UNITS) or NUMBER_OF_UNITS LE 0) then 
      do; 
		 ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=NUMBER_OF_UNITS)"),$160.);
         i_move = 1; 
      end;  /* if (missing(NUMBER_OF_UNITS) or NUMBER_OF_UNITS < 0) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Remove Duplicate  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_pack_id;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.Val_pack_id;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = DI_MON.STG_PACK_HIER_DM_X 
               data = work.ETLS_ERRORS_VW; 
   run; 
   proc append base = work._temp
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
%mend etls_Validate;
%etls_Validate;



/**  Step end Val_pack_id **/

/*============================================================================* 
 * Step:            Load_pack_hier_dm                       A5RCIHUB.BC0009RA * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Val_pack_id - work.Val_pack_id          A5RCIHUB.BE0008FC * 
 * Target Table:    PACK_HIER_DM - DI_DM.PACK_HIER_DM       A5RCIHUB.BR00009L * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RA);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Val_pack_id); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Val_pack_id);

option obs=max;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 

/* --------------------------------------------------------------
   Load Technique Selection: Update - Matching=ModifyUsingIndex, New=ModifyUsingIndex
   Blanks may replace non-blanks: true
   Constraint and index action selections: 'INIT','ASIS','ASIS','ASIS'
   Additional options selections... 
      Set unmapped to missing on updates: false 
   -------------------------------------------------------------- */
%macro etls_loader;

   %let etls_tableOptions = ;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_HIER_DM, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_HIER_DM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_HIER_DM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(PACK_HIER_DM);
   %let etls_lib   = %nrquote(DI_DM);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39H6;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.W5MU39H6 as
         select
            PACK_SK,
            CHILD_PACK_SK,
            NUMBER_OF_UNITS
      from &etls_lastTable
      ;
   quit;
   
   %let SYSLAST = work.W5MU39H6;
   
   %let etls_lastTable = &SYSLAST; 
   %let etls_tableOptions = ; 
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.PACK_HIER_DM, DATA)) or 
         %sysfunc(exist(DI_DM.PACK_HIER_DM, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data DI_DM.PACK_HIER_DM;
         attrib PACK_SK length = 6; 
         attrib CHILD_PACK_SK length = 6; 
         attrib NUMBER_OF_UNITS length = 6; 
         call missing(of _all_);
         stop;
      run;
      
      %rcSet(&syserr); 
      
      /*---- Create the integrity constraints for a table  ----*/ 
      %put %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify PACK_HIER_DM;
            ic create not null (PACK_SK);
            ic create not null (CHILD_PACK_SK);
            ic create PRIM_KEY = primary key (PACK_SK CHILD_PACK_SK);
      quit;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   data DI_DM.PACK_HIER_DM; 
   
      set &etls_lastTable 
             (rename=(NUMBER_OF_UNITS = etls_temp0))
      ; 
      
      modify DI_DM.PACK_HIER_DM
            key = PRIM_KEY;
            
      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or 
         _iorc_ eq %sysrc(_SOK) then  
      do; 
         NUMBER_OF_UNITS = etls_temp0;
         
         /* if the record exists in the master, then replace it  */ 
         if _iorc_ eq %sysrc(_SOK) then 
            replace; 
         
         /* if the record does not exist in the master, then add it  */ 
         else 
            output; 
      end; 
      
      _iorc_ = 0; 
      _error_ = 0; 
      
   run; 
   
   %rcSet(&syserr); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39H6;
   quit;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_HIER_DM, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_HIER_DM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_HIER_DM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;



/**  Step end Load_pack_hier_dm **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendjobstatus(source_table = DIDM_STG.STG_PACK_HIER_DM);
