/* 
SUPPORT: sinsik Kannarath, Sarita
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Pack_pack_group             A5RCIHUB.BA0001XW * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sourabh/My Folder/Cycle_4/Main_SPK                 * 
 *                                                                            * 
 * Server:          MIMain                                  A5RCIHUB.AQ000003 * 
 *                                                                            * 
 * Source Tables:   PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 *                  STG_PACK_PACK_GROUP -                   A5RCIHUB.BR0000OU * 
 *                   DIDM_STG.STG_PACK_PACK_GROUP                             * 
 *                  PACK_GROUP - DI_DM.PACK_GROUP           A5RCIHUB.BR00009J * 
 * Target Table:    PACK_PACK_GROUP - DI_DM.PACK_PACK_GROUP A5RCIHUB.BR00009O * 
 *                                                                            * 
 * Generated on:    Wednesday, November 12, 2008 11:50:40 AM IST              * 
 * Generated by:    sinsoj@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5RCIHUB.BA0001XW);
%let etls_jobName = %nrquote(Load_STG2DM_Pack_pack_group);
%let etls_userID = %nrquote(sinsoj@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;

/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            Uw_check_exist                          A5RCIHUB.BC0009RB * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    STG_PACK_PACK_GROUP -                   A5RCIHUB.BR0000OU * 
 *                   DIDM_STG.STG_PACK_PACK_GROUP                             * 
 * Target Table:    Uw_check_exist -                        A5RCIHUB.BE0008FD * 
 *                   DIDM_STG.STG_PACK_PACK_GROUP                             * 
 *                                                                            * 
 * User Written:    check_exist                                               * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RB);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(DIDM_STG.STG_PACK_PACK_GROUP); 

%let _INPUT_count = 1;
%let _INPUT = DIDM_STG.STG_PACK_PACK_GROUP;
%let _INPUT_connect = ;
%let _INPUT_engine = BASE;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_PACK_GROUP(Table);
%let _INPUT_type = 1;

%let _INPUT1 = DIDM_STG.STG_PACK_PACK_GROUP;
%let _INPUT1_connect = ;
%let _INPUT1_engine = BASE;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Users/Sourabh/My Folder/DIDM_STG/STG_PACK_PACK_GROUP(Table);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = DIDM_STG.STG_PACK_PACK_GROUP;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = BASE;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /Uw_check_exist(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_GROUP_ID PACK_ID;


%let _OUTPUT1 = DIDM_STG.STG_PACK_PACK_GROUP;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = BASE;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /Uw_check_exist(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_GROUP_ID PACK_ID;


/*---- Start of User Written Code  ----*/ 

%macro etl_check_exist;

%let abort = 0 ;

/* Check for existence of DI_DM.PACK_DM dataset */
%if NOT %sysfunc(exist(DI_DM.PACK_DM)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PACK_DM);
	%put &etl_msg;
	%let abort = 1 ;
%end;

/* Check for existence of DI_DM.PACK_GROUP dataset */
%if NOT %sysfunc(exist(DI_DM.PACK_GROUP)) %then 
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PACK_GROUP);
	%put &etl_msg;
	%let abort = 2 ;
%end;

%if &abort gt 0 %then 
%do;
	%etl_abort;
%end;

%mend etl_check_exist;
%etl_check_exist;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_check_exist **/

/*============================================================================* 
 * Step:            Lkp_pack_pack_group                     A5RCIHUB.BC0009RC * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   Uw_check_exist -                        A5RCIHUB.BE0008FD * 
 *                   DIDM_STG.STG_PACK_PACK_GROUP                             * 
 *                  PACK_DM - DI_DM.PACK_DM                 A5RCIHUB.BR00009H * 
 * Target Table:    Lkp_pack_pack_group -                   A5RCIHUB.BE0008FE * 
 *                   work.Lkp_pack_pack_group                                 * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RC);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_pack_pack_group;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_pack_pack_group
         ( keep = PACK_SK PACK_GROUP_ID PACK_ID )
      ; 
   
   attrib PACK_SK length=6
          PACK_GROUP_ID length=8
          PACK_ID length=$32
          ; 
   
   retain missing0-missing0 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_DM.PACK_DM */ 
      nlobs = .; 
      dsid = open("DI_DM.PACK_DM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_DM.PACK_DM", hashexp: exponent);
            h0.defineKey( "PACK_ID");
            h0.defineData( "PACK_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.PACK_DM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.PACK_DM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: DI_DM.PACK_DM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.PACK_DM";
         
         abort 3; 
      end; 
      
      call missing (PACK_ID, PACK_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set DIDM_STG.STG_PACK_PACK_GROUP end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_pack_pack_group; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PACK_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PACK_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_pack_pack_group; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_pack_pack_group **/

/*============================================================================* 
 * Step:            Join_pack_pack_group                    A5RCIHUB.BC0009RD * 
 * Transform:       SQL Join                                                  * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   PACK_GROUP - DI_DM.PACK_GROUP           A5RCIHUB.BR00009J * 
 *                  Lkp_pack_pack_group -                   A5RCIHUB.BE0008FE * 
 *                   work.Lkp_pack_pack_group                                 * 
 * Target Table:    Join_pack_pack_group -                  A5RCIHUB.BE0008FF * 
 *                   work.Join_pack_pack_group                                * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RD);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_pack_pack_group);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Join_pack_pack_group;
quit;

proc sql;
   create table work.Join_pack_pack_group as
   select
      Lkp_pack_pack_group.PACK_GROUP_ID length = 8,
      Lkp_pack_pack_group.PACK_SK length = 6,
      Lkp_pack_pack_group.PACK_ID length = 32,
      PACK_GROUP.PACK_GROUP_ID as PACK_GROUP_ID_CHK length = 8,
      PACK_GROUP.PACK_GROUP_NM length = 40
   from
      work.Lkp_pack_pack_group left join 
      DI_DM.PACK_GROUP
         on
         (
            Lkp_pack_pack_group.PACK_GROUP_ID = PACK_GROUP.PACK_GROUP_ID
         )
   ;
quit;

%rcSet(&sqlrc); 



/**  Step end Join_pack_pack_group **/

/*============================================================================* 
 * Step:            Uw_remove_duplicate                     A5RCIHUB.BC0009RE * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Join_pack_pack_group -                  A5RCIHUB.BE0008FF * 
 *                   work.Join_pack_pack_group                                * 
 * Target Table:    Uw_remove_duplicate -                   A5RCIHUB.BE0008FG * 
 *                   work.Uw_remove_duplicate                                 * 
 *                                                                            * 
 * User Written:    Remove duplicates                                         * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RE);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Join_pack_pack_group); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Join_pack_pack_group);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT_count = 1;
%let _INPUT = work.Join_pack_pack_group;
%let _INPUT_connect = ;
%let _INPUT_engine = ;
%let _INPUT_memtype = DATA;
%let _INPUT_options = %nrquote();
%let _INPUT_alter = %nrquote();
%let _INPUT_path = /Join_pack_pack_group(WorkTable);
%let _INPUT_type = 1;

%let _INPUT1 = work.Join_pack_pack_group;
%let _INPUT1_connect = ;
%let _INPUT1_engine = ;
%let _INPUT1_memtype = DATA;
%let _INPUT1_options = %nrquote();
%let _INPUT1_alter = %nrquote();
%let _INPUT1_path = /Join_pack_pack_group(WorkTable);
%let _INPUT1_type = 1;

%let _OUTPUT_count = 1;
%let _OUTPUT = work.Uw_remove_duplicate;
%let _OUTPUT_connect = ;
%let _OUTPUT_engine = ;
%let _OUTPUT_memtype = DATA;
%let _OUTPUT_options = %nrquote();
%let _OUTPUT_alter = %nrquote();
%let _OUTPUT_path = /Uw_remove_duplicate(WorkTable);
%let _OUTPUT_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT_keep = PACK_GROUP_ID PACK_SK PACK_ID PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND 
        PACK_GROUP_NM;


%let _OUTPUT1 = work.Uw_remove_duplicate;
%let _OUTPUT1_connect = ;
%let _OUTPUT1_engine = ;
%let _OUTPUT1_memtype = DATA;
%let _OUTPUT1_options = %nrquote();
%let _OUTPUT1_alter = %nrquote();
%let _OUTPUT1_path = /Uw_remove_duplicate(WorkTable);
%let _OUTPUT1_type = 1;
/* List of target columns to keep  */ 
%let _OUTPUT1_keep = PACK_GROUP_ID PACK_SK PACK_ID PACK_GROUP_ID_CHK ETLS_EXCEPTION_COND 
        PACK_GROUP_NM;


/*---- Start of User Written Code  ----*/ 

/* SORT for removing duplicates */

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=&SYSLAST out=sort_tab;
	by pack_sk;
run;

%let SYSLAST = %nrquote(work.sort_tab);

data &_OUTPUT;
set &SYSLAST;
by PACK_SK;
attrib ETLS_EXCEPTION_COND length=$100.;
if not(LAST.PACK_SK) then 
   do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5351)"),$100.); 
	end;
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_remove_duplicate **/

/*============================================================================* 
 * Step:            Val_pack_pack_group                     A5RCIHUB.BC0009RF * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Uw_remove_duplicate -                   A5RCIHUB.BE0008FG * 
 *                   work.Uw_remove_duplicate                                 * 
 * Target Table:    Val_pack_pack_group -                   A5RCIHUB.BE0008FH * 
 *                   work.Val_pack_pack_group                                 * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RF);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Uw_remove_duplicate); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Uw_remove_duplicate);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop = PACK_SK PACK_GROUP_ID_CHK PACK_GROUP_NM); quit; %let syslast=&last; 

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.Uw_remove_duplicate"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_pack_pack_group;
   quit;
   
   %let etls_Source = &SYSLAST;
   
   %let m_excp = 0;
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_pack_pack_group
         (keep = PACK_GROUP_ID PACK_SK PACK_ID PACK_GROUP_ID_CHK 
                         ETLS_EXCEPTION_COND PACK_GROUP_NM)
        work.etls_Errors
         (keep = PACK_GROUP_ID PACK_SK PACK_ID PACK_GROUP_ID_CHK 
                         ETLS_EXCEPTION_COND PACK_GROUP_NM)
        work.etls_Exceptions
         (keep = x_row x_column x_type x_action x_note);
   
      set &etls_Source end=eof;
      
      attrib x_row    length = 4    label = "Row Number";
      attrib x_column length = $100 label = "Column Name";
      attrib x_type   length = $50  label = "Type of Exception";
      attrib x_action length = $50  label = "Action Taken";
      attrib x_note   length = $200 label = "Notes";
      
      retain x_note "";
      x_row = _n_;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Invalid Pack_id  ----*/ 
      if (PACK_SK IN (.,-1,0)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_ID)"),$100.); 
      end;  /* if (PACK_SK IN (.,-1,0)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Pack_group_id  ----*/ 
      if (PACK_GROUP_ID ne PACK_GROUP_ID_CHK) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PACK_GROUP_ID)"),$100.); 
      end;  /* if (PACK_GROUP_ID ne PACK_GROUP_ID_CHK) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Remove Duplicate  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_pack_pack_group;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.Val_pack_pack_group;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = DI_MON.STG_PACK_PACK_GROUP_X 
               data = work.ETLS_ERRORS_VW; 
   run; 
   proc append base=work._temp
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %makeReport; 
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
%mend etls_Validate;
%etls_Validate;



/**  Step end Val_pack_pack_group **/

/*============================================================================* 
 * Step:            Load_pack_pack_group                    A5RCIHUB.BC0009RG * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Val_pack_pack_group -                   A5RCIHUB.BE0008FH * 
 *                   work.Val_pack_pack_group                                 * 
 * Target Table:    PACK_PACK_GROUP - DI_DM.PACK_PACK_GROUP A5RCIHUB.BR00009O * 
 *============================================================================*/ 

%let transformID = %quote(A5RCIHUB.BC0009RG);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Val_pack_pack_group); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Val_pack_pack_group);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */ 
options obs=max; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 

/* --------------------------------------------------------------
   Load Technique Selection: Update - Matching=ModifyUsingIndex, New=ModifyUsingIndex
   Blanks may replace non-blanks: true
   Constraint and index action selections: 'INIT','ASIS','ASIS','ASIS'
   Additional options selections... 
      Set unmapped to missing on updates: false 
   -------------------------------------------------------------- */
%macro etls_loader;

   %let etls_tableOptions = ;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_PACK_GROUP, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_PACK_GROUP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_PACK_GROUP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(PACK_PACK_GROUP);
   %let etls_lib   = %nrquote(DI_DM);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39KN;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.W5MU39KN as
         select
            PACK_SK,
            PACK_GROUP_ID
      from &etls_lastTable
      ;
   quit;
   
   %let SYSLAST = work.W5MU39KN;
   
   %let etls_lastTable = &SYSLAST; 
   %let etls_tableOptions = ; 
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.PACK_PACK_GROUP, DATA)) or 
         %sysfunc(exist(DI_DM.PACK_PACK_GROUP, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data DI_DM.PACK_PACK_GROUP;
         attrib PACK_SK length = 6; 
         attrib PACK_GROUP_ID length = 8; 
         call missing(of _all_);
         stop;
      run;
      
      %rcSet(&syserr); 
      
      /*---- Create the integrity constraints for a table  ----*/ 
      %put %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify PACK_PACK_GROUP;
            ic create not null (PACK_SK);
            ic create not null (PACK_GROUP_ID);
            ic create PACK_SK = primary key (PACK_SK);
      quit;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   data DI_DM.PACK_PACK_GROUP; 
   
      set &etls_lastTable 
             (rename=(PACK_GROUP_ID = etls_temp0))
      ; 
      
      modify DI_DM.PACK_PACK_GROUP
            key = PACK_SK;
            
      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or 
         _iorc_ eq %sysrc(_SOK) then  
      do; 
         PACK_GROUP_ID = etls_temp0;
         
         /* if the record exists in the master, then replace it  */ 
         if _iorc_ eq %sysrc(_SOK) then 
            replace; 
         
         /* if the record does not exist in the master, then add it  */ 
         else 
            output; 
      end; 
      
      _iorc_ = 0; 
      _error_ = 0; 
      
   run; 
   
   %rcSet(&syserr); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5MU39KN;
   quit;
   
   /* Get number of records in table  */ 
   %let etls_recCheckExist = 0; 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM.PACK_PACK_GROUP, DATA)) or 
            %sysfunc(exist(DI_DM.PACK_PACK_GROUP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         %local etls_syntaxcheck; 
         %let etls_syntaxcheck = %sysfunc(getoption(syntaxcheck)); 
         /* Turn off syntaxcheck option to perform following steps  */ 
         options nosyntaxcheck;
         
         proc contents data = DI_DM.PACK_PACK_GROUP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
         /* Reset syntaxcheck option to previous setting  */ 
         options &etls_syntaxcheck; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;



/**  Step end Load_pack_pack_group **/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendjobstatus(source_table = DIDM_STG.STG_PACK_PACK_GROUP);
