/* 
SUPPORT: sinass Sharma, Ashish
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Profile                     A5W0V4GZ.BF00028Y * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Sangeeta/My Folder/JOB                             * 
 *                                                                            * 
 * Server:          MIMain                                  A5W0V4GZ.AR000003 * 
 *                                                                            * 
 * Source Tables:   STG_PROFILE - DIDM_STG.STG_PROFILE      A5W0V4GZ.BB0007B9 * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB00077O * 
 *                  STORE_CATEGORY - DI_DM.STORE_CATEGORY   A5W0V4GZ.BB0008Z1 * 
 * Target Table:    PROFILE - DI_DM2.PROFILE                A5W0V4GZ.BB000931 * 
 *                                                                            * 
 * Generated on:    Thursday, September 24, 2009 2:03:14 PM IST               * 
 * Generated by:    sinsro@ROW                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 * History:         Defect: S1207805: Load_STG2DM_Profile.sas fails to delete *
 *                  chunks of profile_id keys for large key values            *
 *                  Defect:S1260888: NF:customer: PUBLISHED_DT in PROFILE need   *
 *                  DATETIME stamp                                            *
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5W0V4GZ.BF00028Y);
%let etls_jobName = %nrquote(Load_STG2DM_Profile);
%let etls_userID = %nrquote(sinsro@ROW);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:            Lkp_prod_hier_store_cat                 A5W0V4GZ.BH000FBA * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   STG_PROFILE - DIDM_STG.STG_PROFILE      A5W0V4GZ.BB0007B9 * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB00077O * 
 *                  STORE_CATEGORY - DI_DM.STORE_CATEGORY   A5W0V4GZ.BB0008Z1 * 
 * Target Table:    Lkp_prod_hier_store_cat -               A5W0V4GZ.BK000CH2 * 
 *                   work.Lkp_prod_hier_store_cat                             * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000FBA);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_prod_hier_store_cat;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_prod_hier_store_cat
         ( keep = PROFILE_ID PROD_HIER_SK PROD_ID PROFILE_NM PROFILE_DESC START_DT END_DT 
                 PUBLISHED_DT STORE_CATEGORY_ID STORE_CATEGORY_NM PUBLISHED_DTTM)
      ; 
   
   attrib PROFILE_ID length=8
          PROD_HIER_SK length=6
          PROD_ID length=$32
          PROFILE_NM length=$100
          PROFILE_DESC length=$100
          START_DT length=8 format=DATE9.
          END_DT length=8 format=DATE9.
          PUBLISHED_DTTM length=8 informat=NLDATM21. format=NLDATM21.
          STORE_CATEGORY_ID length=8
          STORE_CATEGORY_NM length=$40
          ; 
   
   retain missing0-missing1 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_MON.PROD_HIER_SK */ 
      nlobs = .; 
      dsid = open("DI_MON.PROD_HIER_SK"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table DI_DM.STORE_CATEGORY */ 
      nlobs = .; 
      dsid = open("DI_DM.STORE_CATEGORY"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "DI_DM.STORE_CATEGORY", hashexp: exponent);
            h1.defineKey( "STORE_CATEGORY_NM");
            h1.defineData( "STORE_CATEGORY_ID");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.STORE_CATEGORY";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.STORE_CATEGORY";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.STORE_CATEGORY";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.STORE_CATEGORY";
         
         abort 3; 
      end; 
      
      call missing (PROD_ID, PROD_HIER_SK, STORE_CATEGORY_NM, STORE_CATEGORY_ID); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set DIDM_STG.STG_PROFILE end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
   end; 
   else 
      rc1 = missing1; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_prod_hier_store_cat; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (STORE_CATEGORY_ID); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (STORE_CATEGORY_ID); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_prod_hier_store_cat; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 



/**  Step end Lkp_prod_hier_store_cat **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Uw_remove_duplicates                    A5W0V4GZ.BH00061A * 
 * Transform:       User Written                                              * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Lkp_prod_hier_store_cat -               A5W0V4GZ.BK0004YV * 
 *                   work.Lkp_prod_hier_store_cat                             * 
 * Target Table:    Uw_remove_duplicates -                  A5W0V4GZ.BK0004YW * 
 *                   work.Uw_remove_duplicates                                * 
 *                                                                            * 
 * User Written:    Remove duplicates                                         * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH00061A);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Lkp_prod_hier_store_cat); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Lkp_prod_hier_store_cat);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;
%let _INPUT = work.Lkp_prod_hier_store_cat;
%let _OUTPUT = work.Uw_remove_duplicates;


/* SORT for removing duplicates */

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=&SYSLAST out=sort_tab;
   by PROFILE_ID;
run;

%let SYSLAST = %nrquote(work.sort_tab);

Data &_output(rename=(PUBLISHED_DTTM=PUBLISHED_DT));
   set &syslast;
   attrib ETLS_EXCEPTION_COND length=$120;
   by PROFILE_ID ;
   if not last.PROFILE_ID then 
   ETLS_EXCEPTION_COND = "%etl_msg(mid=5303,args=PROFILE_ID)";
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;
%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end Uw_remove_duplicates **/


/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Val_stg_profile                         A5W0V4GZ.BH000FBC * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Uw_remove_duplicates -                  A5W0V4GZ.BK000CH3 * 
 *                   work.Uw_remove_duplicates                                * 
 * Target Table:    Val_stg_profile - work.Val_stg_profile  A5W0V4GZ.BK000CH4 * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000FBC);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Uw_remove_duplicates); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Uw_remove_duplicates);

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_PROFILE_X;
quit;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   /* Create the Exception Report  */ 
   %macro makeReport; 
   
      %if (&m_excp eq 1) %then 
      %do; 
         options nodate; 
         
         proc sort data = work.etls_Exceptions; 
            by x_row; 
         run; 
         
         proc print data = work.etls_Exceptions noobs label; 
            title1 "Exceptions Found in Table: work.Uw_remove_duplicates"; 
            title2 "%sysfunc(datetime(),nldatmap.)"; 
         run; 
         
         options date; 
         
      %end; 
      
   %mend makeReport; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_stg_profile;
   quit;
   
   %let etls_Source = &SYSLAST;
   
   %let m_excp = 0;
   
   %put %str(NOTE: Cannot create target table as view because error records are moved.);
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_stg_profile
         (keep = PROD_HIER_SK PROFILE_ID PROD_ID PROFILE_NM PROFILE_DESC START_DT 
                         END_DT PUBLISHED_DT ETLS_EXCEPTION_COND STORE_CATEGORY_ID 
                         STORE_CATEGORY_NM)
        work.etls_Errors
         (keep = PROD_HIER_SK PROFILE_ID PROD_ID PROFILE_NM PROFILE_DESC START_DT 
                         END_DT PUBLISHED_DT ETLS_EXCEPTION_COND STORE_CATEGORY_ID 
                         STORE_CATEGORY_NM);
   
      set &etls_Source end=eof;
      
      i_move = 0;
      retain i_excp &m_excp; 
      
      /*---- Custom Validation: Check Start Date  ----*/ 
      if (START_DT  > END_DT) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5322,args=Start_date End_date)"),$120.);; 
      end;  /* if (START_DT  > END_DT) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Profile id  ----*/ 
      if ((NOT (0 < PROFILE_ID < 2147483648)) OR PROFILE_ID NE FLOOR(PROFILE_ID)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROFILE_ID)"),$120.);; 
      end;  /* if ((NOT (0 < PROFILE_ID < 2147483648)) OR PROFILE_ID NE FLOOR(PROFILE_ID)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Prod_id  ----*/ 
      if (MISSING(PROD_HIER_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$120.);; 
      end;  /* if (MISSING(PROD_HIER_SK)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Invalid Store_category_nm  ----*/ 
      if (MISSING(STORE_CATEGORY_ID)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=STORE_CATEGORY_NM)"),$120.);; 
      end;  /* if (MISSING(STORE_CATEGORY_ID)) */
      else 
      do; 
      end;  /* else */
      
      /*---- Custom Validation: Remove Duplicate  ----*/ 
      if (ETLS_EXCEPTION_COND ne "") then 
      do; 
         i_move = 1; 
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else 
      do; 
      end;  /* else */
      
      /* move record to error file  */ 
      if (i_move) then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_stg_profile;
         
      if eof then 
      do; 
         /* create macro flags  */ 
         call symput("m_excp", put(i_excp, 1.));
      end; 
   
   run; 
   
   %rcSet(&syserr); 
   
   %let etls_Source = work.Val_stg_profile;
   
   /* add ETL_Error_JobRunTime variable to error table  */ 
   data work.etls_Errors; 
      set work.etls_Errors; 
      format ETL_Error_JobRunTime datetime16.; 
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt; 
   run; 
   
   /* update the errors table  */ 
   proc append base = WORK.STG_PROFILE_X
               data = work.etls_Errors force; 
   run; 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;
   
   %goto STEP_CONTINUE;
   
   %STEP_ERR:
   
      %let sysrc = 9999; 
      %rcSet(&sysrc); 
      
   %STEP_CONTINUE:
   
%mend etls_Validate;
%etls_Validate;

/*---- Start of Post-Process Code  ----*/ 

proc append base=DI_MON.STG_PROFILE_X
data=WORK.STG_PROFILE_X 
(keep=%di_util_column_names(DI_MON.STG_PROFILE_X));
run;
/*---- End of Post-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 



/**  Step end Val_stg_profile **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW_DBMS_Load_Profile                    A5W0V4GZ.BH00061C * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Val_stg_profile - work.Val_stg_profile  A5W0V4GZ.BK0004YX * 
 * Target Table:    PROFILE - DI_DM2.PROFILE                A5W0V4GZ.BB000602 * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH00061C);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let SYSLAST = %nrquote(work.Val_stg_profile); 

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/ 

%di_etl_keep_work_table(Val_stg_profile);
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let SYSLAST = &ETLS_SYSLAST;

%let _INPUT = work.Val_stg_profile;
%let _OUTPUT = DI_DM2.PROFILE;

%global etls_tableExist;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_lastTable = &SYSLAST; 

/* System options  */ 
options obs=max; 

%let etls_recordsBefore = 0;
%let etls_table = %nrquote(PROFILE);
%let etls_lib   = %nrquote(DI_DM2);

%macro etls_recordCheck(varname); 
  %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM2.PROFILE, DATA)) or 
        %sysfunc(exist(DI_DM2.PROFILE, VIEW))); 
  
  %if (&etls_recCheckExist) %then
  %do;
     proc sql noprint;
        select count(*) into :&varname from DI_DM2.PROFILE;
     quit;
  %end;
%mend etls_recordCheck;

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %local etls_match_rec_count;
   %let etls_match_rec_count = 0;
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM2.PROFILE, DATA)) or 
         %sysfunc(exist(DI_DM2.PROFILE, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
      %etl_msg(mid=5005,args=DI_DM2.PROFILE);
     %etl_abort;
   %end;  /* if table does not exist  */ 

   /* Get number of records in table  */ 
   %etls_recordCheck(etls_recordsBefore);
 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_existrecords ;
   quit;

   %if (&etls_recordsBefore gt 0) %then 
   %do;  /* if has rows */ 

   %di_dm_trans_extract(
   di_trans=&di_trans,
   trans_table=profile,
   all_trans=0,
   _output_table=profile,
   select_list=%str(PROFILE_ID)
   );
   
   proc sort data = profile;
   by PROFILE_ID;
   run;
   
   data etls_existrecords;
   format PROFILE_ID 15.;
   merge profile (in = dm)
         &etls_lastTable (in = stg);
   by PROFILE_ID;
   if stg and dm;
   run;

      %let etls_match_rec_count = %di_util_nobs(WORK.etls_existrecords);
      %rcSet(&sqlrc); 
    
   %end; /* if has rows */ 

    proc sql;
         create view etls_newrecords as 
         select PROD_HIER_SK length = 8,
                PROFILE_ID length = 8,
                PROFILE_NM    length = 100,
      PROFILE_DESC  length = 100,
      START_DT length = 8,
      END_DT length = 8,
      PUBLISHED_DT length = 8,
      STORE_CATEGORY_ID length = 8
         from   &etls_lastTable;
      quit;
      %rcSet(&sqlrc); 
  
   /*--- Delete existing data from the master table ----*/
   %if &etls_match_rec_count gt 0 %then 
   %do;
       %di_dm_trans_delete(
   di_trans=&di_trans,
   trans_table=profile ,
   delete_join_table=Etls_existrecords ,
   delete_join_cond=A.profile_id=B.profile_id,
   chunk = 0);

   %rcSet(&syserr); 
   %end;
   /*---- Append new data  ----*/ 

   %di_dm_trans_append(
   di_trans=&di_trans,
   trans_table=PROFILE,
   append_table=Etls_newrecords,
   bulkload=1,
   fk_flag=0,
   upload_flag=0
   )
  
   %rcSet(&syserr); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_existrecords;
   quit;

   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0;
   %etls_recordCheck(etls_recordsAfter);  

%mend etls_loader;
%etls_loader;

%rcSet(&syserr); 
%rcSet(&sqlrc); 


/**  Step end UW_DBMS_Load_Profile **/


/*---- End of User Written Code  ----*/ 

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendjobstatus(source_table = DIDM_STG.STG_PROFILE);
