/* 
SUPPORT: sinavk Khairnar, Avinash
*/ 
/******************************************************************************
 * Job:             Load_STG2DM_Src_size_cd                 A5W0V4GZ.BF0004CM *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Ashish/My Folder/Jobs                              *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB000653 *
 *                  STG_SRC_SIZE - DIDM_STG.STG_SRC_SIZE    A5W0V4GZ.BB0006AV *
 * Target Table:    SRC_SIZE_CD - DI_DM2.SRC_SIZE_CD        A5W0V4GZ.BB00060F *
 *                                                                            *
 * Generated on:    Friday, January 29, 2010 4:38:14 PM IST                   *
 * Generated by:    sinass@ROW                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0004CM);
%let etls_jobName = %nrquote(Load_STG2DM_Src_size_cd);
%let etls_userID = %nrquote(sinass@ROW);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;

%macro rcSetDS(error);
   if &error gt input(symget('trans_rc'),12.) then
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS;

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

/*============================================================================*
 * Step:            UW-Check global settings                A5W0V4GZ.BH000KRJ *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_SRC_SIZE - DIDM_STG.STG_SRC_SIZE    A5W0V4GZ.BB0006AV *
 * Target Table:    User Written Code Target -              A5W0V4GZ.BK000H9K *
 *                   DIDM_STG.STG_SRC_SIZE                                    *
 *                                                                            *
 * User Written:    Get global setting var                                    *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRJ); *Sarita:<---Is this really needed?;
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DIDM_STG.STG_SRC_SIZE);

/*---- Start of User Written Code  ----*/

%global G_SRC_CD_PROD_LVL;

%macro etl_check_exist;

%let abort = 0 ;

/* Check for existence of DI_DM.PRODUCT_DM dataset */
%if NOT %sysfunc(exist(DI_DM.PRODUCT_DM)) %then
%do;
   %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_DM);
   %put &etl_msg;
   %let abort = 1 ;
%end;


/*Get size translation prod level from global settings*/
PROC SQL noprint;
   select spec_value into :g_src_cd_prod_lvl
   from di_dm.global_setting
   where upcase(spec_nm)='SIZE_TRANSLATION_PROD_LVL';
QUIT;

%if &g_src_cd_prod_lvl eq %str() %then
%do;
   %let etl_msg = %etl_msg(mid=5007,args=SIZE_TRANSLATION_PROD_LVL GLOBAL_SETTING);
   %put &etl_msg;
   %let abort = 2 ;
%end;

%put G_SRC_CD_PROD_LVL=&g_src_cd_prod_lvl;

%if &abort gt 0 %then
%do;
   %etl_abort;
%end;

%mend etl_check_exist;

%etl_check_exist;
/*---- End of User Written Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);


/**  Step end UW-Check global settings **/

/*============================================================================*
 * Step:            SAS Extract                             A5W0V4GZ.BH000KRK *
 * Transform:       Extract                                                   *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    PRODUCT_DM - DI_DM.PRODUCT_DM           A5W0V4GZ.BB000653 *
 * Target Table:    Extract Target - work.EXT_PRODUCT_DM    A5W0V4GZ.BK000H9L *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRK);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DI_DM.PRODUCT_DM);

/*---- Map the columns  ----*/
proc datasets lib = work nolist nowarn memtype = (data view);
   delete EXT_PRODUCT_DM;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create view work.EXT_PRODUCT_DM as
      select
         (max(PROD_HIER_SK)) as PROD_HIER_SK length = 6,
         PROD_ID,
         (max(STD_HIER_PROD_LVL)) as STD_HIER_PROD_LVL length = 4
   from &SYSLAST
   group by
      PROD_ID
   ;
quit;

%let SYSLAST = work.EXT_PRODUCT_DM;

%di_etl_rcset(error=&sqlrc,code=job_rc);



/**  Step end SAS Extract **/

/*============================================================================*
 * Step:            Lookup                                  A5W0V4GZ.BH000KRL *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   User Written Code Target -              A5W0V4GZ.BK000H9K *
 *                   DIDM_STG.STG_SRC_SIZE                                    *
 *                  Extract Target - work.EXT_PRODUCT_DM    A5W0V4GZ.BK000H9L *
 * Target Table:    Lookup Target - work.STG_SRC_SIZE_LKP   A5W0V4GZ.BK000H9M *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRL);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let runTime = %sysfunc(datetime());

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5T62O1G;
quit;

/*---- Begin DATA step to perform lookups  ----*/
DATA  work.W5T62O1G
         ( keep = SRC_SIZE_CD PROD_ID SRC_SIZE_NM PROD_HIER_SK PROD_LVL
                 ETLS_EXCEPTION_COND )
      ;

   attrib SRC_SIZE_CD length=6
          PROD_ID length=$32
          SRC_SIZE_NM length=$40
          PROD_HIER_SK length=6
          PROD_LVL length=4
          ETLS_EXCEPTION_COND length=$200
          STD_HIER_PROD_LVL length= 4
          ;

   retain missing0-missing0 0;

   etls_assign_target_value = 0;
   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then do;
      /* Build hash h0 from lookup table work.EXT_PRODUCT_DM */
      nlobs = .;
      dsid = open("work.EXT_PRODUCT_DM");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then nlobs = attrn(dsid, 'NLOBS');
         else nlobs = -1;
         dsid = close(dsid);
         if (nlobs ^= 0) then do;
            if (nlobs > 0) then exponent = ceil(log2(nlobs));
            else exponent = 8;
            declare hash h0(dataset: "work.EXT_PRODUCT_DM", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK","STD_HIER_PROD_LVL");
            h0.defineDone();
            if (nlobs = -1) then do;
               if (h0.Num_Items < 1) then do;
                  put "NOTE: Lookup table is empty: work.EXT_PRODUCT_DM";
                  missing0 = 98;
               end;
            end;
         end;
         else do;
            put "NOTE: Lookup table is empty: work.EXT_PRODUCT_DM";
            missing0 = 98;
         end;
      end;
      else do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " work.EXT_PRODUCT_DM";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " work.EXT_PRODUCT_DM";

         abort 9999;
      end;

      call missing (PROD_ID, PROD_HIER_SK, STD_HIER_PROD_LVL);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set DIDM_STG.STG_SRC_SIZE end = eof;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then do;
      rc0 = h0.find();
      PROD_LVL = STD_HIER_PROD_LVL;
   end;
   else rc0 = missing0;

   /* Examine success of lookups  */
   if ( rc0=0 ) then do;
      /* Write row to target  */
      output work.W5T62O1G;
      return;
   end;
   else do;
      error_total + 1;
      if (rc0 ^= 0) then
      do;
         exception_total + 1;
         if (rc0 = 98) then do;
            /* Check: Lookup table has no rows-Write exception row  */
            /* Check: Lookup table has no rows-Set target columns to value  */
            /* Check: Lookup table has no rows-Set target columns to missing  */
            call missing (PROD_HIER_SK, PROD_LVL);
            etls_assign_target_value = 1;
         end;
         else do;
            /* Check: Lookup value not found-Set target columns to missing  */
            call missing (PROD_HIER_SK, PROD_LVL);
            etls_assign_target_value = 1;
         end;
      end;

      /* Set target columns to value/missing requested?  */
      if (etls_assign_target_value eq 1) then
         /* Write row to target  */
         output work.W5T62O1G;

   end; /* One or more lookups failed */

   if (eof = 1) then
   do;
      put "Source records with errors: " error_total ;
      put "Total lookup exceptions: " exception_total ;
   end;

run;

%di_etl_rcset(error=&syserr,code=job_rc);

/*---- Map the columns  ----*/
proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_SRC_SIZE_LKP;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create table work.STG_SRC_SIZE_LKP as
      select
         SRC_SIZE_CD,
         PROD_ID,
         SRC_SIZE_NM,
         PROD_HIER_SK,
         PROD_LVL,
         (put('',$200.)) as ETLS_EXCEPTION_COND length = 200
   from work.W5T62O1G;
quit;
%di_etl_rcset(error=&sqlrc,code=job_rc);
%let SYSLAST = work.STG_SRC_SIZE_LKP;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5T62O1G;
quit;



/**  Step end Lookup **/

/*============================================================================*
 * Step:            Chk_Duplicates                          A5W0V4GZ.BH000KRM *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lookup Target - work.STG_SRC_SIZE_LKP   A5W0V4GZ.BK000H9M *
 * Target Table:    User Written Code Target -              A5W0V4GZ.BK000H9N *
 *                   work.STG_SRC_SIZE_NODUP                                  *
 *                                                                            *
 * User Written:    Check duplicates                                          *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRM);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.STG_SRC_SIZE_LKP);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(STG_SRC_SIZE_LKP);
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

%let SYSLAST = &ETLS_SYSLAST;

%let _OUTPUT = work.STG_SRC_SIZE_NODUP;
/*---- Start of User Written Code  ----*/

/* SORT for removing duplicates */

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=&SYSLAST out=work.sort_tab;
   by SRC_SIZE_CD PROD_HIER_SK;
run;

data &_OUTPUT;
set work.sort_tab;
by SRC_SIZE_CD PROD_HIER_SK;
if not(last.PROD_HIER_SK) then
   do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"*%etl_msg(mid=5351)"),$200.);
   end;
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;
/*---- End of User Written Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);


/**  Step end Chk_Duplicates **/

/*============================================================================*
 * Step:            Data Validation                         A5W0V4GZ.BH000KRN *
 * Transform:       Data Validation                                           *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    User Written Code Target -              A5W0V4GZ.BK000H9N *
 *                   work.STG_SRC_SIZE_NODUP                                  *
 * Target Table:    Data Validation -                       A5W0V4GZ.BK000H9O *
 *                   work.STG_SRC_SIZE_VALID                                  *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRN);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.STG_SRC_SIZE_NODUP);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(STG_SRC_SIZE_NODUP);
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

%let SYSLAST = &ETLS_SYSLAST;

/* System options  */
options ;%let last=&syslast; proc sql; create view work.etls_errors_vw as select * from work.etls_errors(drop=SRC_SIZE_NM PROD_HIER_SK); quit; %let syslast=&last;
%di_etl_rcset(error=&sqlrc,code=job_rc);

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate;

   %let runTime = %sysfunc(datetime());

   /* Create the Exception Report  */
   %macro makeReport;

      %if (&m_excp eq 1) %then
      %do;
         options nodate;

         proc sort data = work.etls_Exceptions;
            by x_row;
         run;

         proc print data = work.etls_Exceptions noobs label;
            title1 "Exceptions Found in Table: work.STG_SRC_SIZE_NODUP";
            title2 "%sysfunc(datetime(),nldatmap.)";
         run;

         options date;

      %end;

   %mend makeReport;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete STG_SRC_SIZE_VALID;
   quit;

   %let etls_Source = &SYSLAST;

   %let m_excp = 0;

   %put %str(NOTE: Cannot create target table as view because error records are moved.);

   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/
   data work.STG_SRC_SIZE_VALID
         (keep = SRC_SIZE_CD PROD_ID SRC_SIZE_NM PROD_HIER_SK PROD_LVL
                         ETLS_EXCEPTION_COND)
        work.etls_Errors
         (keep = SRC_SIZE_CD PROD_ID SRC_SIZE_NM PROD_HIER_SK PROD_LVL
                         ETLS_EXCEPTION_COND);

      set &etls_Source end=eof;

      i_move = 0;
      retain i_excp &m_excp;

      /*---- Custom Validation: Prod_ID Lkp Check  ----*/
      if (PROD_HIER_SK IN( -1, 0, .)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$200.);
         i_move = 1;
      end;  /* if (PROD_HIER_SK IN( -1, 0, .)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: PROD_LVL should be at GLOBAL_SETTINGS  ----*/
      /*----  src_code_prod_lvl                                        ----*/
      if (PROD_LVL ne input(symget('g_src_cd_prod_lvl'),32.)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5315,args=PROD_LVL-of-PROD_ID SIZE_TRANS_PROD_LVL )"),$200.);
         i_move = 1;
      end;  /* if (PROD_LVL ne input(symget('g_src_cd_prod_lvl'),32.)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Invalid values check  ----*/
      if  SRC_SIZE_CD < 0 or
          SRC_SIZE_CD >= 2147483648 or
          SRC_SIZE_CD ne int(SRC_SIZE_CD) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=SRC_SIZE_CD)"),$200.);
         i_move = 1;
      end;  /* if (NOT (0 <= SRC_SIZE_CD < 2147483648)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Remove Duplicate  ----*/
      if (ETLS_EXCEPTION_COND ne "") then
      do;
         i_move = 1;
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else
      do;
      end;  /* else */

      /* move record to error file  */
      if (i_move) then
         output work.etls_Errors;
      /* move record to output file  */
      else
         output work.STG_SRC_SIZE_VALID;

      if eof then
      do;
         /* create macro flags  */
         call symput("m_excp", put(i_excp, 1.));
      end;

   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   %let etls_Source = work.STG_SRC_SIZE_VALID;

   /* add ETL_Error_JobRunTime variable to error table  */
   data work.etls_Errors;
      set work.etls_Errors;
      format ETL_Error_JobRunTime datetime16.;
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /* update the errors table  */
   proc append base = DI_MON.STG_SRC_SIZE_X 
               data = work.ETLS_ERRORS_VW; 
   run; 
   proc append base=work._temp
               data = work.etls_Errors force;
   run;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;

   %goto STEP_CONTINUE;

   %STEP_ERR:

      %let sysrc = 9999;
      %rcSet(&sysrc);

   %STEP_CONTINUE:

%mend etls_Validate;
%etls_Validate;



/**  Step end Data Validation **/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            UW-Load SRC_SIZE_CD                     A5W0V4GZ.BH000KRO *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Data Validation -                       A5W0V4GZ.BK000H9O *
 *                   work.STG_SRC_SIZE_VALID                                  *
 * Target Table:    SRC_SIZE_CD - DI_DM2.SRC_SIZE_CD        A5W0V4GZ.BB00060F *
 *                                                                            *
 * User Written:    UW-Load SRC_SIZE_CD                                       *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000KRO);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%di_etl_keep_work_table(STG_SRC_SIZE_VALID);

/* System options  */
options obs=max;

%let etls_recordsBefore = 0;
%let etls_table = %nrquote(SRC_SIZE_CD);
%let etls_lib   = %nrquote(DI_DM2);

%macro etls_recordCheck(varname);
  %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM2.SRC_SIZE_CD, DATA)) or
        %sysfunc(exist(DI_DM2.SRC_SIZE_CD, VIEW)));

  %if (&etls_recCheckExist) %then
  %do;
     proc sql noprint;
        select count(*) into :&varname from DI_DM2.SRC_SIZE_CD;
     quit;
  %end;
%mend etls_recordCheck;
%di_etl_rcset(error=&sqlrc,code=job_rc);

/*---- Define load data macro  ----*/
%macro etls_loader;

   /* Determine if the target table exists  */
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM2.SRC_SIZE_CD, DATA)) or
         %sysfunc(exist(DI_DM2.SRC_SIZE_CD, VIEW)));

   %if (&etls_tableExist eq 0) %then %do;  /* if table does not exist  */
      %etl_msg(mid=5005,args=DI_DM2.SRC_SIZE_CD);
     %etl_abort;
   %end;  /* if table does not exist  */

   /* Get number of records in table  */
   %etls_recordCheck(etls_recordsBefore);

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_existrecords Src_size_cd;
   quit;

   %if (&etls_recordsBefore gt 0) %then %do;  /* if has rows */
      %di_dm_trans_extract(
         di_trans      = di_dm2,
         trans_table   = Src_size_cd,
         all_trans     = 0,
         _output_table = Src_size_cd);

        proc sort data=Src_size_cd;
           by src_size_cd prod_hier_sk;
        run;
      %let vars_to_keep = %di_util_column_names(Src_size_cd);
        /* create a temp table of matching records & new records from source and transactio table */
        data etls_existrecords;
          merge Src_size_cd(in=dm) STG_SRC_SIZE_VALID(in=stg);
          by src_size_cd prod_hier_sk;
          keep &vars_to_keep;
          if dm and stg then output etls_existrecords;
        run;
        %di_etl_rcset(error=&syserr,code=job_rc);
         %let etls_match_rec_count = %di_util_nobs(etls_existrecords);
      /*--- Remove existing data in the master table ----*/
      %if %symexist(etls_match_rec_count) %then %do;
            %if &etls_match_rec_count gt 0 %then %do;
              %di_dm_trans_delete(
               di_trans=di_dm2,
               trans_table=SRC_SIZE_CD,
               delete_join_table=work.etls_existrecords,
               delete_join_cond=%str(a.SRC_SIZE_CD=b.SRC_SIZE_CD and a.prod_hier_sk=b.prod_hier_sk),
               chunk = 1);
         %end;
            %di_etl_rcset(error=&syserr,code=job_rc);
      %end;
   %end;
  /* Create view on input dataset to append */
    proc sql;
       create view etls_newrecords as
          select SRC_SIZE_CD,
          SRC_SIZE_NM,
          PROD_HIER_SK
        from STG_SRC_SIZE_VALID;
     quit;
     %di_etl_rcset(error=&sqlrc,code=job_rc);
   /*---- Append data  ----*/
   %di_dm_trans_append(
      di_trans=di_dm2,
      trans_table=SRC_SIZE_CD,
      append_table=etls_newrecords);

   %di_etl_rcset(error=&syserr,code=job_rc);

   /* Get number of records in table  */
   %let etls_recordsAfter = 0;
   %etls_recordCheck(etls_recordsAfter);

%mend etls_loader;
%etls_loader;
%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);


/**  Step end UW-Load SRC_SIZE_CD **/


/*---- End of User Written Code  ----*/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/
%etls_sendJobStatus(source_table=didm_stg.stg_src_size);

