/*
SUPPORT: sinavk Khairnar, Avinash
*/
/******************************************************************************
 * Job:             Load_STG2DM_STD_size_cd                 A5W0V4GZ.BF0002KM *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Rhuta/My Folder/New jobs                           *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   STG_STD_SIZE - DIDM_STG.STG_STD_SIZE    A5W0V4GZ.BB000AQ0 *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000AJS *
 * Target Table:    STD_SIZE_CD - DI_DM2.STD_SIZE_CD        A5W0V4GZ.BB0003WX *
 *                                                                            *
 * Generated on:    Friday, October 16, 2009 12:07:58 PM IST                  *
 * Generated by:    sinruk@row                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0002KM);
%let etls_jobName = %nrquote(Load_STG2DM_STD_size_cd);
%let etls_userID = %nrquote(sinruk@row);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;

%macro rcSetDS(error);
   if &error gt input(symget('trans_rc'),12.) then
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS;

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

%macro etl_check_exist;

   %let abort = 0 ;

   /* Check for existence of DI_MON.PROD_HIER_SK dataset */
   %if NOT %sysfunc(exist(DI_MON.PROD_HIER_SK)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_MON.PROD_HIER_SK);
      %put &etl_msg;
      %let abort = 1 ;
   %end;
   %else %do;
    %let prod_hier_sk_obs = %di_util_nobs(DI_MON.PROD_HIER_SK);
    %if &prod_hier_sk_obs = 0 %then
    %do;
      %let etl_msg = %etl_msg(mid=5203,args=DI_MON.PROD_HIER_SK);
      %put &etl_msg;

    %end;
   %end;

   %if &abort gt 0 %then %do;
      %etl_abort;
   %end;

%mend etl_check_exist;

%etl_check_exist;

/*============================================================================*
 * Step:            Lookup                                  A5W0V4GZ.BH000HLE *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   User Written Code Target -              A5W0V4GZ.BK000EE0 *
 *                   DIDM_STG.STG_STD_SIZE                                    *
 *                  Extract Target - work.EXT_PRODUCT_DM    A5W0V4GZ.BK000EDZ *
 * Target Table:    Lookup Target - work.STG_STD_SIZE_LKP   A5W0V4GZ.BK000EE1 *
 *============================================================================*/

proc datasets lib = work nolist nowarn memtype = (data view);
   delete STG_STD_SIZE_LKP;
quit;
/*---- Begin DATA step to perform lookups  ----*/

DATA  work.STG_STD_SIZE_LKP
         ( keep = STD_SIZE_CD PROD_ID STD_SIZE_NM DISPLAY_ORDER PROD_HIER_SK etls_exception_cond);
   set DIDM_STG.STG_STD_SIZE;

   attrib STD_SIZE_CD length=6
          PROD_ID length=$32 label="Product Hierarchy Key"
          STD_SIZE_NM length=$40
          DISPLAY_ORDER length=6
          PROD_HIER_SK length=6 label="Product Hierarchy Key"
          ETLS_EXCEPTION_COND length=$200;

   if (_n_ = 1) then do;
      /* Build hash h0 from lookup table di_mon.Prod_hier_sk */
     declare hash h0(dataset: "di_mon.Prod_hier_sk", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK");
            h0.defineDone();
   end; /* Hash objects have been defined */

   rc0 = h0.find();

   if ( rc0=0) then do;
      /* Write row to target  */
      output work.STG_STD_SIZE_LKP;
      return;
   end;
   else if (rc0 ^= 0) then do;
      etls_excp_cnt = 1;
   end;

   if (etls_excp_cnt eq 1) then do;
      output work.STG_STD_SIZE_LKP;
   end; /* One or more lookups failed */
run;

%di_etl_rcset(error=&syserr,code=job_rc);

/**  Step end Lookup **/

/*============================================================================*
 * Step:            Sort_STG_STD_SIZE_CD                                      *
 * Transform:       Sort                                                      *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_STD_SIZE_LKP                                          *
 *                   work.STG_STD_SIZE_LKP                                    *
 * Target Table:    STG_STD_SIZE_NODUP - work.STG_STD_SIZE_NODUP              *
 *============================================================================*/

%di_etl_keep_work_table(STG_STD_SIZE_LKP);

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

proc sort data=WORK.STG_STD_SIZE_LKP out=work.sort_tab;
   by STD_SIZE_CD;
run;

data WORK.STG_STD_SIZE_NODUP;
  set work.sort_tab;
   by std_size_cd;
   if not(last.std_size_cd) then do;
      ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"*%etl_msg(mid=5351)"),$200.);
   end;
run;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete sort_tab;
quit;

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

/*---- End of User Written Code  ----*/

/*============================================================================*
 * Step:            Data Validation                         A5W0V4GZ.BH000HLG *
 * Transform:       Data Validation                                           *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    User Written Code Target -              A5W0V4GZ.BK000EE2 *
 *                   work.STG_STD_SIZE_NODUP                                  *
 * Target Table:    Data Validation Target -                A5W0V4GZ.BK000EE3 *
 *                   work.STG_STD_SIZE_VALID                                  *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HLG);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(STG_STD_SIZE_NODUP);
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

/* System options  */
options ;
%let last=STG_STD_SIZE_NODUP;

proc sql;
  create view work.etls_errors_vw as
  select *
  from work.etls_errors(drop=STD_SIZE_NM PROD_HIER_SK);
quit;

%di_etl_rcset(error=&sqlrc,code=job_rc);

%put %str(NOTE: Cannot create exception report because a view has been selected as
      output.);

%macro etls_Validate;

   %let runTime = %sysfunc(datetime());

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete STG_STD_SIZE_VALID;
   quit;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_STG_STD_SIZE_VALID;
   quit;

   %let m_excp = 0;

   %put %str(NOTE: Cannot create target table as view because error records are moved.);

   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/
   data work.etls_STG_STD_SIZE_VALID
         (keep = STD_SIZE_CD STD_SIZE_NM DISPLAY_ORDER PROD_HIER_SK
                         ETLS_EXCEPTION_COND)
        work.etls_Errors
         (keep = STD_SIZE_CD PROD_ID STD_SIZE_NM DISPLAY_ORDER PROD_HIER_SK
                         ETLS_EXCEPTION_COND);

      /* Define lengths for columns with longer lengths in target  */
      attrib PROD_HIER_SK length = 8
         label = 'Product Hierarchy Key';

      set STG_STD_SIZE_NODUP end=eof;

      i_move = 0;
      retain i_excp &m_excp;

      /*---- Custom Validation: Prod_ID Lkp Check  ----*/
      if (PROD_HIER_SK IN( -1, 0, .)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5306,args=PROD_ID)"),$200.);
         i_move = 1;
      end;  /* if (PROD_HIER_SK IN( -1, 0, .)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Invalid values check  ----*/


      if  STD_SIZE_CD < 0 or
          STD_SIZE_CD >= 2147483648 or
          STD_SIZE_CD ne int(STD_SIZE_CD) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=STD_SIZE_CD)"),$200.);
         i_move = 1;
      end;  /* if (NOT (0 <= STD_SIZE_CD < 2147483648)) */
      else
      do;
      end;  /* else */

      /*---- Custom Validation: Remove Duplicate  ----*/
      if (ETLS_EXCEPTION_COND ne "") then
      do;
         i_move = 1;
      end;  /* if (ETLS_EXCEPTION_COND ne "") */
      else
      do;
      end;  /* else */

      /* move record to error file  */
      if (i_move) then
         output work.etls_Errors;
      /* move record to output file  */
      else
         output work.etls_STG_STD_SIZE_VALID;

      if eof then
      do;
         /* create macro flags  */
         call symput("m_excp", put(i_excp, 1.));
      end;

   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   %let etls_Source = work.etls_STG_STD_SIZE_VALID;

   /* add ETL_Error_JobRunTime variable to error table  */
   data work.etls_Errors;
      set work.etls_Errors;
      format ETL_Error_JobRunTime datetime16.;
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   /* update the errors table  */
   proc append base = DI_MON.STG_STD_SIZE_X
               data = work.ETLS_ERRORS_VW;
   run; 

   proc append base = work._temp
               data = work.etls_Errors force;
   run;

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_Errors;
   quit;

   /*---- Map the columns  ----*/
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete STG_STD_SIZE_VALID;
   quit;

   %put %str(NOTE: Mapping columns ...);
   proc sql;
      create view work.STG_STD_SIZE_VALID as
         select
            STD_SIZE_CD,
            STD_SIZE_NM,
            DISPLAY_ORDER,
            PROD_HIER_SK length = 8
      from work.etls_STG_STD_SIZE_VALID
      ;
   quit;

   %di_etl_rcset(error=&sqlrc,code=job_rc);

   %goto STEP_CONTINUE;

   %STEP_ERR:

      %let sysrc = 9999;
      %rcSet(&sysrc);

   %STEP_CONTINUE:

%mend etls_Validate;
%etls_Validate;


/**  Step end Data Validation **/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Load_STG2DM_STD_size_cd                                   *
 * Transform:       Table Loader                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    stg_std_size_valid - work.stg_std_size_valid              *
 * Target Table:    STD_SIZE_CD -                                             *
 *                   DI_DM2.STD_SIZE_CD                                       *
 *============================================================================*/

%global etls_tableExist;
%let etls_tableExist = -1;

options obs=max;

%let etls_recordsBefore = 0;
%let etls_table = %nrquote(STD_SIZE_CD);
%let etls_lib   = %nrquote(DI_DM2);

%macro etls_recordCheck(varname);
  %let etls_recCheckExist = %eval(%sysfunc(exist(DI_DM2.STD_SIZE_CD, DATA)) or
        %sysfunc(exist(DI_DM2.STD_SIZE_CD, VIEW)));

  %if (&etls_recCheckExist) %then
  %do;
     proc sql noprint;
        select count(*) into :&varname from DI_DM2.STD_SIZE_CD;
     quit;

     %di_etl_rcset(error=&sqlrc,code=job_rc);
  %end;
%mend etls_recordCheck;

/*---- Define load data macro  ----*/
%macro etls_loader;

   /* Determine if the target table exists  */
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM2.STD_SIZE_CD, DATA)) or
         %sysfunc(exist(DI_DM2.STD_SIZE_CD, VIEW)));

   %if (&etls_tableExist eq 0) %then %do;  /* if table does not exist  */
      %etl_msg(mid=5005,args=DI_DM2.STD_SIZE_CD);
      %etl_abort;
   %end;  /* if table does not exist  */

   /* Get number of records in table  */
   %etls_recordCheck(etls_recordsBefore);

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_existrecords Std_size_cd;
   quit;

   %if (&etls_recordsBefore gt 0) %then %do;  /* if has rows */
      %di_dm_trans_extract( di_trans      = di_dm2,
                            trans_table   = std_size_cd,
                            all_trans     = 0,
                            _output_table = std_size_cd);

      proc sort data=Std_size_cd;
         by std_size_cd prod_hier_sk;
      run;

      %let vars_to_keep = %di_util_column_names(Std_size_cd);

      /* create a temp table of matching records & new records from source and transactio table */
      data etls_existrecords;
        merge std_size_cd(in=dm) stg_std_size_valid(in=std);
        by std_size_cd;
        keep &vars_to_keep;
        if dm and std then output etls_existrecords;
      run;

      %di_etl_rcset(error=&syserr,code=job_rc);

      %let etls_match_rec_count = %di_util_nobs(etls_existrecords);

      /*--- Remove existing data in the master table ----*/
      %if %symexist(etls_match_rec_count) %then %do;
          %if &etls_match_rec_count gt 0 %then %do;

            %di_dm_trans_delete( di_trans=di_dm2,
                                 trans_table=std_size_cd,
                                 delete_join_table=work.etls_existrecords,
                                 delete_join_cond=%str(a.std_size_cd=b.std_size_cd),
                                 chunk = 1);
          %end;

          %di_etl_rcset(error=&syserr,code=job_rc);
      %end;
   %end;

   /* Create view on input dataset to append */

    proc sql;
         create view etls_newrecords as
         select std_size_cd,
         std_size_nm,
         prod_hier_sk,
         display_order
         from stg_std_size_valid;
    quit;

   %di_etl_rcset(error=&sqlrc,code=job_rc);

   /*---- Append data  ----*/

   %di_dm_trans_append(
      di_trans=di_dm2,
      trans_table=std_size_cd,
      append_table=etls_newrecords);
   %di_etl_rcset(error=&syserr,code=job_rc);


   /* Get number of records in table  */
   %let etls_recordsAfter = 0;

   %etls_recordCheck(etls_recordsAfter);

%mend etls_loader;
%etls_loader;

%di_etl_rcset(error=&syserr,code=job_rc);
%di_etl_rcset(error=&sqlrc,code=job_rc);

/*---- End of User Written Code  ----*/

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/
%etls_sendJobStatus(source_table=didm_stg.stg_std_size);

