/**************************************************************************************************

NAME:             update_pricing_relation_attr                              

DESCRIPTION:      update di_trans.pricing_relation. By default, eplace the character "," with "|"  
                  in attr_value_list1 and attr_value_list2
                  update di_trans.pricing_reln_match_attr. Replace the character "," with "|"  
                  in match_attr_value_list
HISTORY:          02MAR2017: Macro introduced to resolve issue surfaced by customer
                  S1325748 - 7612035559
*************************************************************************************************/

%macro di_util_update_pricing_reln_attr(src_delim=,tgt_delim=);

%if "&src_delim"="" %then
    %do;
	   %let src_delim=%str(,);
	%end;
%if "&tgt_delim"="" %then
    %do;
	   %let tgt_delim=%str(|);
	%end;
	
%put ______ src_delim=&src_delim;
%put ______ tgt_delim=&tgt_delim;

proc sql noprint;
   update di_trans.pricing_relation 
      set attr_value_list1=tranwrd(attr_value_list1,"&src_delim","&tgt_delim");
   update di_dm2.pricing_relation 
      set attr_value_list2=tranwrd(attr_value_list2,"&src_delim","&tgt_delim");
   update di_trans.pricing_reln_match_attr
      set match_attr_value_list=tranwrd(match_attr_value_list,"&src_delim","&tgt_delim");
quit;

%mend;

%*di_util_update_pricing_reln_attr(src_delim=%str(,),tgt_delim=%str(|));
